Package: Deducer
Version: 0.9-2
Date: 2026-05-05
Title: A Data Analysis GUI for R
Authors@R: c(person(given = "Ian",
                      family = "Fellows",
                      role = c("aut","cre"),
                      email = "ian@fellstat.com"))
Maintainer: Ian Fellows <ian@fellstat.com>
Description: An intuitive, cross-platform graphical data analysis system. It uses menus and dialogs to guide the user efficiently through the data manipulation and analysis process, and has an excel like spreadsheet for easy data frame visualization and editing. Deducer works best when used with the Java based R GUI JGR, but the dialogs can be called from the command line. Dialogs have also been integrated into the Windows Rgui.
Depends: R (>= 2.15.0), ggplot2 (>= 2.0.0), JGR(>= 1.7-10), car, MASS
Imports: rJava, e1071, scales, plyr, foreign, multcomp, effects
Suggests: Hmisc, brunnermunzel, cli
SystemRequirements: Java, JRI
License: GPL-2
URL: https://www.deducer.org/ https://www.fellstat.com
NeedsCompilation: no
Packaged: 2026-05-06 08:25:26 UTC; ianfellows
Author: Ian Fellows [aut, cre]
Repository: CRAN
Date/Publication: 2026-05-06 21:10:02 UTC
Built: R 4.5.2; ; 2026-05-06 23:33:37 UTC; unix

Package: Deducer
Version: 0.9-2
Date: 2026-05-05
Title: A Data Analysis GUI for R
Authors@R: c(person(given = "Ian",
                      family = "Fellows",
                      role = c("aut","cre"),
                      email = "ian@fellstat.com"))
Maintainer: Ian Fellows <ian@fellstat.com>
Description: An intuitive, cross-platform graphical data analysis system. It uses menus and dialogs to guide the user efficiently through the data manipulation and analysis process, and has an excel like spreadsheet for easy data frame visualization and editing. Deducer works best when used with the Java based R GUI JGR, but the dialogs can be called from the command line. Dialogs have also been integrated into the Windows Rgui.
Depends: R (>= 2.15.0), ggplot2 (>= 2.0.0), JGR(>= 1.7-10), car, MASS
Imports: rJava, e1071, scales, plyr, foreign, multcomp, effects
Suggests: Hmisc, brunnermunzel, cli
SystemRequirements: Java, JRI
License: GPL-2
URL: https://www.deducer.org/ https://www.fellstat.com
NeedsCompilation: no
Packaged: 2026-05-06 08:25:26 UTC; ianfellows
Author: Ian Fellows [aut, cre]
Repository: CRAN
Date/Publication: 2026-05-06 21:10:02 UTC
Built: R 4.6.0; ; 2026-05-07 00:03:20 UTC; unix

exportPattern("[[:alpha:]]+")
import(rJava)
import(JGR)
import(MASS)
import(car)
import(e1071, except=element)
import(effects)
import(foreign)
importFrom(scales, ContinuousRange,
 DiscreteRange,
 abs_area,
 area_pal,
 as.trans,
 asn_trans,
 atanh_trans,
 boxcox_trans,
 brewer_pal,
 cbreaks,
 censor,
 col2hcl,
 col_bin,
 col_factor,
 col_numeric,
 col_quantile,
 colour_ramp,
 comma,
 comma_format,
 cscale,
 date_breaks,
 date_format,
 date_trans,
 dichromat_pal,
 discard,
 div_gradient_pal,
 dollar,
 dollar_format,
 dscale,
 exp_trans,
 expand_range,
 extended_breaks,
 format_format,
 fullseq,
 gradient_n_pal,
 grey_pal,
 hue_pal,
 identity_pal,
 identity_trans,
 is.trans,
 linetype_pal,
 log10_trans,
 log1p_trans,
 log2_trans,
 log_breaks,
 log_trans,
 logit_trans,
 manual_pal,
 math_format,
 muted,
 ordinal,
 ordinal_format,
 parse_format,
 percent,
 percent_format,
 pretty_breaks,
 probability_trans,
 probit_trans,
 reciprocal_trans,
 rescale,
 rescale_max,
 rescale_mid,
 rescale_none,
 rescale_pal,
 reverse_trans,
 scientific,
 scientific_format,
 seq_gradient_pal,
 shape_pal,
 show_col,
 sqrt_trans,
 squish,
 squish_infinite,
 time_trans,
 train_continuous,
 train_discrete,
 trans_breaks,
 trans_format,
 trans_new,
 trans_range,
 unit_format,
 wrap_format,
 zero_range)
import(ggplot2)
import(multcomp)
import(plyr)
importFrom("stats", "as.formula", "chisq.test", "coef",
             "complete.cases", "cor", "cor.test", "fisher.test",
             "kruskal.test", "mantelhaen.test", "median", "na.omit",
             "oneway.test", "pchisq", "pt", "quantile", "relevel", "sd",
             "t.test", "var")
importFrom("utils", "capture.output", "menu")

S3method(plot, cor.matrix)
S3method(print, contin.table)
S3method(print,  contin.tests)
S3method(print,  contingency.tables)
S3method(print,  cor.matrix)
S3method(print,  freq.table)
S3method(print,  multi.test)

S3method(as.matrix,cor.matrix)
S3method(sort,data.frame)

# TODO: Add comment
# 
# Author: ianfellows
###############################################################################


rocplot<-function(logistic.model,diag=TRUE,pred.prob.labels=FALSE,prob.label.digits=3,AUC=TRUE){
	Spec <- Sens <- NULL
	##Adapted from lroc in epicalc
	firsttable <- table(logistic.model$fitted.values, logistic.model$y)
	colnames(firsttable) <- c("Non-diseased", "Diseased")
	firsttable1 <- cbind(as.numeric(rownames(firsttable)), firsttable)
	rownames(firsttable1) <- rep("", nrow(firsttable1))
	colnames(firsttable1)[1] <- "predicted.prob"
	secondtable <- firsttable
	for (i in 1:length(secondtable[, 1])) {
		secondtable[i, 1] <- (sum(firsttable[, 1]) - sum(firsttable[(1:i), 
									1]))/sum(firsttable[, 1])
		secondtable[i, 2] <- (sum(firsttable[, 2]) - sum(firsttable[(1:i), 
									2]))/sum(firsttable[, 2])
	}
	secondtable <- as.data.frame(rbind((c(1, 1)), secondtable))
	colnames(secondtable) <- c("Spec", "Sens")
	rownames(secondtable)[1] <- "0"
	model.des <- paste("logit (", deparse(logistic.model$formula), 
			")", sep = "")
	auc <- 0
	for (i in 1:(nrow(secondtable) - 1)) {
		auc <- auc + (secondtable[i, 1] - secondtable[(i + 1), 
							1]) * 0.5 * (secondtable[i, 2] + secondtable[(i + 
										1), 2])
	}
	p<-qplot(Spec, Sens,data=secondtable[nrow(secondtable):1,], xlab = "1-Specificity", 
			ylab = "Sensitivity",main=model.des, xlim = (c(0, 1)), ylim = (c(0, 1)))+geom_step()
	if(diag)
		p<-p+geom_segment(x=0,y=0,xend=1,yend=1,colour="red",size=1.5)
	if(pred.prob.labels)
		p<-p+geom_text(size=3,angle=-45,hjust=-.3,aes(x=Spec,y=Sens,
						label=formatC(as.numeric(rownames(secondtable)),
								digits=prob.label.digits)))
	if(AUC)
		p<-p+annotate("text",x=.8,y=0.05,label=paste("AUC=",formatC(auc,digits=4)))
	p
}

cor.matrix<-function(variables,with.variables,data=NULL,test=cor.test,...){
	arguments <- as.list(match.call()[-1])
	variables<-eval(substitute(variables),data,parent.frame())
	if(length(dim(variables))<1.5){
		variables<-d(variables)
		fn <- arguments$variables
		names(variables)<-if(is.call(fn)) format(fn) else as.character(fn)
	}
	if(missing(with.variables))
		with.variables <-variables
	else{
		with.variables<-eval(substitute(with.variables),data,parent.frame())
		if(length(dim(with.variables))<1.5){
			with.variables<-d(with.variables)
			fn <- arguments$with.variables
			names(with.variables)<-if(is.call(fn)) format(fn) else as.character(fn)
		}		
	}
	cors<-list()
	for(var1 in colnames(variables)){
		cors[[var1]]<-list()
		for(var2  in colnames(with.variables)){
			tmp<-na.omit(data.frame(as.numeric(variables[[var1]]),as.numeric(with.variables[[var2]])))
			names(tmp)<-c(var1,var2)
			cors[[var1]][[var2]]<-test(tmp[[1]],tmp[[2]],...)
			attr(cors[[var1]][[var2]],"N")<-nrow(tmp)
		}
	}
	class(cors)<-"cor.matrix"
	cors
}

print.cor.matrix<-function(x,digits=4,N=TRUE,CI=TRUE,stat=TRUE,p.value=TRUE,...){
	if(is.null(x[[1]][[1]]$conf.int))
		CI=FALSE
	n1<-length(x)
	n2<-length(x[[1]])
	label.width<-7
	num.rows<-6	
	result<-as.table(matrix(NA,nrow=n2*num.rows,ncol=n1))
	r.names<-names(x[[1]])
	r.name.width<-max(nchar(r.names))
	if(r.name.width>20){
		r.names<-formatC(r.names,width=20)
		r.name.width<-20
	}else
		r.names<-formatC(r.names,width=r.name.width)
	c.names<-names(x)
	if(max(nchar(c.names))>20)
		c.names<-format(names(x),width=15)
	colnames(result)<-c.names
	for(i in 1:n2)
		rownames(result)[i*num.rows-(num.rows-1)]<-paste(formatC(r.names[i],width=r.name.width),
				formatC("cor",width=label.width),sep="")
	
	
	rownames(result)[rep(1:num.rows,n2)>1.5]<-formatC(rep(c("N","CI*","stat**","p-value",
							paste(rep("-",r.name.width+label.width),collapse="")),n2),
			width=r.name.width+label.width)
	for(j in 1:n1){
		for(i in (1:n2)){
			result[i*num.rows-(num.rows-1),j]<-format(x[[j]][[i]]$estimate,digits=digits,...)
			if(!is.null(attr(x[[j]][[i]],"N")))
				result[i*num.rows-(num.rows-2),j]<-format(attr(x[[j]][[i]],"N"),...)
			if(names(x[[1]])[i]==names(x)[j])
				next
			if(!is.null(x[[j]][[i]]$conf.int))
				result[i*num.rows-(num.rows-3),j]<-paste("(",format(x[[j]][[i]]$conf.int[1],digits=digits,...),",",
						format(x[[j]][[i]]$conf.int[2],digits=digits,...),")",sep="")
			if(!is.null(x[[j]][[i]]$statistic)){
				if(!is.null(x[[j]][[i]]$parameter)){
					if(length(x[[j]][[i]]$parameter)==1)
						result[i*num.rows-(num.rows-4),j]<-paste(format(x[[j]][[i]]$statistic,digits=digits,...),
								" (",format(x[[j]][[i]]$parameter,digits=digits,...),")",
								sep="")
					else
						result[i*num.rows-(num.rows-4),j]<-paste(format(x[[j]][[i]]$statistic,digits=digits,...),
								" (",format(x[[j]][[i]]$parameter[1],digits=digits,...),",",
								format(x[[j]][[i]]$parameter[2],digits=digits,...),")",
								sep="")
				}else
					result[i*num.rows-(num.rows-4),j]<-format(x[[j]][[i]]$statistic,digits=digits,...)
			}
			if(!is.null(x[[j]][[i]]$p.value))
				result[i*num.rows-(num.rows-5),j]<-format(round(x[[j]][[i]]$p.value,digits),
						digits=digits,nsmall=digits,...)
		}
	}
	display<-if(CI) rep(TRUE,num.rows*n2) else rep(1:num.rows,n2)!=3
	display<-display & (if(N) rep(TRUE,num.rows*n2) else rep(1:num.rows,n2)!=2)
	display<-display & (if(stat) rep(TRUE,num.rows*n2) else rep(1:num.rows,n2)!=4)
	display<-display & (if(p.value) rep(TRUE,num.rows*n2) else rep(1:num.rows,n2)!=5)
	cat("\n",format(x[[1]][[1]]$method, width = getOption("width"), justify = "centre"), "\n\n")
	print(as.table(result[display,,drop=FALSE]))
	if(stat & !is.null(x[[1]][[1]]$statistic)){
		cat("\t**",names(x[[1]][[1]]$statistic)[1])
		if(!is.null(x[[1]][[1]]$parameter))
			if(length(x[[1]][[1]]$parameter)==1)
				cat(" (",names(x[[1]][[1]]$parameter[1]),")\n",sep="")
			else
				cat(" (",names(x[[1]][[1]]$parameter[1]),",",names(x[[1]][[1]]$parameter[2]),")\n",sep="")
		else
			cat("\n")
	}
	if(CI & !is.null(x[[1]][[1]]$conf.int))
		if(!is.null(attr(x[[1]][[1]]$conf.int,"conf.level")))
			cat("\t * ",attr(x[[1]][[1]]$conf.int,"conf.level")*100,"% percent interval\n\n",sep="")
		else
			cat("\n")
	if(!is.null(x[[1]][[1]]$alternative))
		cat("\tHA:",x[[1]][[1]]$alternative,"\n\n")
	else
		cat("\n")
}

as.matrix.cor.matrix<-function(x,...){
	n1<-length(x);
	n2<-length(x[[1]])
	mat<-matrix(NA,n2,n1)
	for(i in 1:n2)
		for(j in 1:n1)
			mat[i,j]<-x[[j]][[i]]$estimate
	colnames(mat)<-names(x)
	rownames(mat)<-names(x[[1]])
	mat
}

perm<-function(vec,duplicates=FALSE) 
{
	if(!is.vector(vec))
		stop("vec must be a vector")
	n<-length(vec)
    if (n == 1) 
        return(as.matrix(vec[1]))
    else if (n < 2) 
        return(NULL)
    z <- matrix(1)
	if(all(!duplicated(vec)))
		duplicates=TRUE
    for (i in 2:n) {
        x <- cbind(z, i)
        a <- c(1:i, 1:(i - 1))
        z <- matrix(0, ncol = ncol(x), nrow = i * nrow(x))
        z[1:nrow(x), ] <- x
        for (j in 2:i - 1) {
            z[j * nrow(x) + 1:nrow(x), ] <- x[, a[1:i + j]]
        }
    }
    dimnames(z) <- NULL
	z<-apply(z,c(1,2),function(x) vec[x])
    if(!duplicates) z[!duplicated(z),] else z
}


table.to.data<-function(x){
	x<-as.matrix(x)
	d<-dim(x)
	res<-matrix(,ncol=2,nrow=sum(x))
	rn<-rownames(x)
	if(is.null(rn))
		rn<-1:d[1]
	cn<-colnames(x)
	if(is.null(cn))
		cn<-1:d[2]
	cnt<-1
	for(i in 1:d[1])
		for(j in 1:d[2]){
			if(x[i,j]==0)
				next
			tmp<-matrix(rep(c(rn[i],cn[j]),x[i,j]),ncol=2,byrow=TRUE)
			res[cnt:(cnt+x[i,j]-1),]<-tmp
			cnt<-cnt+x[i,j]
		}
	
	res<-as.data.frame(res)
	res[[1]]<-factor(res[[1]],levels=rn)
	res[[2]]<-factor(res[[2]],levels=cn)
	res
}
	


dich<-function(variables,data=NULL,cut=NULL,group1=NULL,group2=NULL){
	arguments <- as.list(match.call()[-1])
	variables<-eval(substitute(variables),data,parent.frame())
	if(length(dim(variables))<1.5){
		variables<-d(variables)
		fn<-arguments$variables
		names(variables)<-if(is.call(fn)) format(fn) else as.character(fn)
	}
	for(var in names(variables)){
		x<-variables[[var]]
		if(!is.null(cut)){
			cutpoint<-deparse(substitute(cut))
			x<- recode.variables(x , paste("Lo:",cutpoint," -> '<",cutpoint,"';",cutpoint,":Hi -> '>=",cutpoint,"';",sep=""))[[1]]
			x<-factor(x)
		}else{
			x<-factor(x)
			if(!is.null(group1) && is.null(group2)){
				name<-deparse(substitute(group1))
				x<-recode.variables(x, paste(name," -> '",name,"';else -> 'Not",name,"';"))[[1]]
			}
			if(is.null(group1) && !is.null(group2)){
				name<-deparse(substitute(group2))
				x<-recode.variables(x, paste(name," -> '",name,"';else -> 'Not",name,"';"))[[1]]
			}
			if(!is.null(group1) && !is.null(group2)){
				name1<-deparse(substitute(group1))
				name2<-deparse(substitute(group2))
				x<-recode.variables(x, paste(name1," -> '",name1,"';",name2," -> '",name2,
								"';else -> NA;"))[[1]]
			}
		}
		if(var == names(variables)[1]){
			result<-d(x)
			names(result)<-paste(var,".grp",sep="")
		}else
			result[[paste(var,".grp",sep="")]] <- x
	}
	result
}

d<-function(..., row.names = NULL, check.rows = FALSE,
                check.names = FALSE,
                stringsAsFactors = FALSE){
	data.frame(...,row.names=row.names,check.rows=check.rows,check.names=check.names,stringsAsFactors=stringsAsFactors)
}


get.objects<-function(cn=NULL,env = globalenv(),includeInherited=TRUE){
	objs <- ls(envir=env)
	if(is.null(cn))
		return(objs)
		
	l <- list()	
	for(obj in objs){
		if(!includeInherited)
			call <- paste("'",cn,"'"," == class(",obj,")[1]",sep="")
		else
			call <-paste("'",cn,"'"," %in% class(",obj,")",sep="")
		include <- try(eval(parse(text=call), envir=env),silent=TRUE)
		if(!inherits(include,"try-error") && include)
			l[[length(l)+1]] <- obj
	}
	result<- unlist(l)
	if(is.null(result))
		result <- character()
	result
}

# TODO: Add comment
# 
# Author: ianfellows
###############################################################################




########################################################################
#
#				paired test
#
########################################################################

.makePairedTestDialog <- function(){
	RFunction <- J("org.rosuda.deducer.widgets.param.RFunction")
	RFunctionDialog <- J("org.rosuda.deducer.widgets.param.RFunctionDialog")
	Param<- J("org.rosuda.deducer.widgets.param.Param")
	ParamAny <- J("org.rosuda.deducer.widgets.param.ParamAny")
	ParamVariable <- J("org.rosuda.deducer.widgets.param.ParamVariable")
	ParamMultipleVariables <- J("org.rosuda.deducer.widgets.param.ParamMultipleVariables")
	ParamLogical <- J("org.rosuda.deducer.widgets.param.ParamLogical")
	ParamCharacter<- J("org.rosuda.deducer.widgets.param.ParamCharacter")
	ParamNumeric<- J("org.rosuda.deducer.widgets.param.ParamNumeric")
	ParamRObject<- J("org.rosuda.deducer.widgets.param.ParamRObject")
	ParamRFunctionResult<- J("org.rosuda.deducer.widgets.param.ParamRFunctionResult")
	RFunctionList<- J("org.rosuda.deducer.widgets.param.RFunctionList")
	RFunctionListDialog <- J("org.rosuda.deducer.widgets.param.RFunctionListDialog")
	RFunctionDialog <- J("org.rosuda.deducer.widgets.param.RFunctionDialog")	
	
	
	
	
	#functions for dialog
	rf <- new(RFunction,"t.test")
	rfw <- new(RFunction,"wilcox.test")
	
	
	#make parameters and add them to the functions
	pv1 <- new(ParamVariable,"x")
	pv1$setTitle("First")
	rf$add(pv1)
	rfw$add(pv1)
	
	
	pv2 <- new(ParamVariable,"y")
	pv2$setTitle("Second")
	rf$add(pv2)
	rfw$add(pv2)
	
	
	p <- new(ParamCharacter,"alternative","two.sided")
	p$setTitle("Type")
	p$setOptions(c("two.sided","less","greater"))
	p$setViewType(p$VIEW_COMBO)
	rf$add(p)
	rfw$add(p$clone())
	
	p <- new(ParamNumeric,"conf.level",.95)
	p$setLowerBound(0)
	p$setUpperBound(1)
	rf$add(p)
	rfw$add(p$clone())
	
	p <- new(ParamLogical,"paired",TRUE)
	p$setDefaultValue(FALSE)
	p$setViewType(p$VIEW_HIDDEN)
	rf$add(p)
	rfw$add(p)
	
	#make function list and add functions
	prf <- new(RFunctionList,"Paired tests");
	prf$setViewType(p$VIEW_RFUNCTION_PANEL)
	prf$addRFunction("t-test",rf,FALSE)
	prf$addRFunction("Wilcoxon signed rank",rfw,FALSE)
	prf$setRequiresVariableSelector(TRUE)
	prf$setActiveFunctions("t-test")
	#parameters common to all functions should go at the top
	globals <- .jarray(list(pv1,pv2),"org.rosuda.deducer.widgets.param.Param")
	prf$setGlobalParams(globals)
	
	
	#make dialog and display
	rfd <- new(RFunctionListDialog, prf )
	rfd$setSize(500L,520L)
	rfd$setLocationRelativeTo(.jnull())
	rfd
}

sort.data.frame<-function(x,decreasing,by,...){
	signs<-c()
	get.signs<-function(f){
		l<-length(signs)
		lf<-length(f)
		if(as.character(f[[1]]) %in% c("+","-")){
			signs[l+1]<<-as.character(f[[1]])
			names(signs)[l+1]<<-if(is.call(f[[lf]])) format(f[[lf]]) else as.character(f[[lf]])
			if(lf>2){
				if(!is.symbol(f[[2]]))
					get.signs(f[[2]])
				if(lf>=3 && !is.symbol(f[[3]]))
					get.signs(f[[3]])	
			}			
		}
	}
	bycall<-as.list(match.call()[-1])$by
	bycall<-gsub(" ","",if(is.call(bycall)) format(bycall) else as.character(bycall))
	if(substr(bycall,1,1) != "~")
		by<-as.formula(paste("~",bycall))
	
	if(length(gregexpr("~",format(by))[[1]])>1.5)
		stop("formula must be one-sided")	
	
	# If the first character is not + or -, add +
	formc <- as.character(by[2]) 
	if(!is.element(substring(formc, 1, 1), c("+", "-")))
		formc <- paste("+", formc, sep = "")
	
	f<-as.formula(paste("~1 ",formc))
	
	
	get.signs(f[[2]])
	signs<-rev(signs)
	mf<-as.data.frame(lapply(names(signs),function(nm) eval(parse(text=nm),x, parent.frame())))
	names(mf)<-names(signs)
	if(nrow(mf)!=nrow(x))
		stop("error: 'by' specification implies incorrect numbers of rows")
	
	# Build a list of arguments to pass to "order" function
	calllist <- list()
	for(i in 1:length(signs)){
		varsign <- signs[i]
		v<-mf[[names(signs)[i]]]
		if(is.factor(v)){
			if(varsign == "-") {
				calllist[[i]] <- -rank(v)
			} else {
				calllist[[i]] <- rank(v)
			}
		} else {
			if(varsign == "-") {
				calllist[[i]] <- -v
			} else {
				calllist[[i]] <- v
			}
		}
	}
	return(x[do.call("order", calllist), , drop=FALSE])
}

one.sample.test<-function(variables,data=NULL,test=t.test,...){
	arguments <- as.list(match.call()[-1])
	vars<-eval(substitute(variables),data, parent.frame())
	if(length(dim(vars))<1.5){
		vars<-d(vars)
		fn<-arguments$variables
		names(vars)<-if(is.call(fn)) format(fn) else as.character(fn)
	}
	data <- vars
	tests<-list(NULL)
	for(i in 1:ncol(data)){
		if(is.character(data[[i]])){
			cat(paste("'",names(data)[i],
					"' is a character vector. Attempting to coerse into a numeric one.\n",sep=""))
			data[[i]]<-as.numeric(data[[i]])
		}
		if(is.factor(data[[i]])){
			cat(paste("'",names(data)[i],
					"' is a factor. Attempting to coerse into numeric.\n",sep=""))
			data[[i]]
			tmp<-as.numeric(as.character(data[[i]]))
			if(length(na.omit(tmp))==length(na.omit(data[[i]])))
				data[[i]] <- tmp
			else
				data[[i]] <- as.numeric(data[[i]])
		}
		if(is.logical(data[[i]])){
			data[[i]]<-as.numeric(data[[i]])
		}
		if(!is.numeric(data[[i]])){
			warning(paste("'",names(data)[i],
					"' is not numeric. It will be dropped.\n",sep=""))
			next
		}
		if(length(na.omit(data[[i]]))<3){
			warning(paste("'",names(data)[i],
					"' has fewer than 3 valid values. It will be dropped.",sep=""))
			next
		}
		tests[[names(data)[i]]]<-test(na.omit(data[[i]]),...)
	}
	multi.test(tests)
}

qscatter_array<-function(variables,with.variables,data=NULL,x.lab="",y.lab="",
		main="Correlation Array",common.scales=TRUE,alpha=.25){
	arguments <- as.list(match.call()[-1])
	variables<-eval(substitute(variables),data,parent.frame())
	if(length(dim(variables))<1.5){
		variables<-d(variables)
		fn <- arguments$variables
		names(variables)<-if(is.call(fn)) format(fn) else as.character(fn)
	}
	if(missing(with.variables))
		with.variables <-variables
	else{
		with.variables<-eval(substitute(with.variables),data,parent.frame())
		if(length(dim(with.variables))<1.5){
			with.variables<-d(with.variables)
			fn <- arguments$with.variables
			names(with.variables)<-if(is.call(fn)) format(fn) else as.character(fn)
		}		
	}
	data1<-variables
	data2<-with.variables
	n<-nrow(data1)
	tmp<-rep(NA,n*ncol(data1)*ncol(data2))
	tmp.data<-data.frame(x=tmp,y=tmp,x.var=tmp,y.var=tmp)
	filled<-FALSE
	st<-1
	x<-1
	y<-1
	while(!filled){
		tmp.data[st:(st+n-1),1]<-data1[,x]
		tmp.data[st:(st+n-1),2]<-data2[,y]
		tmp.data[st:(st+n-1),3]<-names(data1)[x]
		tmp.data[st:(st+n-1),4]<-names(data2)[y]
		if(x>=ncol(data1) && y>=ncol(data2))
			filled<-TRUE
		if(y>=ncol(data2)){
			x<-x+1
			y<-1
		}else
			y<-y+1
		st<-st+n
	}
	p<-ggplot(tmp.data,aes(y,x))+geom_point(alpha=alpha)+facet_grid(x.var~y.var,scales="free")
	if(!common.scales)
		p<-p+facet_wrap(x.var~y.var,ncol=ncol(data2),scales="free")
	if(ncol(data1)==1 && y.lab=="")
		p<-p+ylab(names(data1)[1])
	else
		p<-p+ylab(y.lab)
	if(ncol(data2)==1 && x.lab=="")
		p<-p+xlab(names(data2)[1])
	else
		p<-p+xlab(x.lab)
	p+ggtitle(main)
}

.registerDialog <- function(name,generator){
	if(bindingIsLocked(".dialogGenerators", asNamespace("Deducer")))
		unlockBinding(".dialogGenerators", asNamespace("Deducer"))
	dg <- .dialogGenerators
	dg[[name]] <- generator
	.dialogGenerators <<- dg
}

.getDialog <- function(name,newInstance=FALSE){
	if(bindingIsLocked(".dialogs", asNamespace("Deducer")))
		unlockBinding(".dialogs", asNamespace("Deducer"))
	dialog <- .dialogs[[name]]
	if(is.null(dialog) || newInstance){
		dialog <- .dialogGenerators[[name]]()
		if(!newInstance){
			di <- .dialogs
			di[[name]] <- dialog
			.dialogs <<- di
		}
	}
	dialog
}

.deducerExecute<-function(cmd){
    .ensureJRI()
    cmds<-parse(text=cmd)
    for(i in 1:length(cmds)){
        out<-eval(parse(text=paste("capture.output(",as.character(cmds[i]),")")),globalenv())
        for(line in out)
            cat(line,"\n")
    }
}

#.jChooserMacLAF<-function(){
#
#	if(Sys.info()[1]!="Darwin") stop("Silly rabbit, Mac Look And Feel is only for Macs!")
#	
#	.jaddClassPath("./System/Library/Java")
#	.jaddLibrary("quaqua",system.file("java/quaqua","libquaqua.jnilib",package="Deducer"))
#	.jaddLibrary("quaqua64",system.file("java/quaqua","libquaqua64.jnilib",package="Deducer"))
#	.jpackage("Deducer","quaqua.jar")
#	
#	#HashSet <- J("java.util.HashSet")
#	QuaquaManager <- J("ch.randelshofer.quaqua.QuaquaManager")
#	
#	#excludes <- new(HashSet)
#	#excludes$add("TitledBorder")
#	#excludes$add("Button")
#	#QuaquaManager$setExcludedUIs(excludes)
#	
#	#J("java.lang.System")$setProperty("Quaqua.visualMargin","0,0,0,0")
#	
#	J("javax.swing.UIManager")$setLookAndFeel(QuaquaManager$getLookAndFeel())
#}

.assign.classnames <- function(){
	DeducerMain <<- J("org.rosuda.deducer.Deducer")

	SimpleRDialog <<- J("org.rosuda.deducer.widgets.SimpleRDialog") 
	SimpleRSubDialog <<- J("org.rosuda.deducer.widgets.SimpleRSubDialog")
	RDialog <<- J("org.rosuda.deducer.widgets.RDialog") 

	VariableSelectorWidget <<- J("org.rosuda.deducer.widgets.VariableSelectorWidget")
	VariableListWidget <<- J("org.rosuda.deducer.widgets.VariableListWidget")
	CheckBoxesWidget <<- J("org.rosuda.deducer.widgets.CheckBoxesWidget")
	ButtonGroupWidget <<- J("org.rosuda.deducer.widgets.ButtonGroupWidget")
	SingleVariableWidget <<- J("org.rosuda.deducer.widgets.SingleVariableWidget")
	SliderWidget <<- J("org.rosuda.deducer.widgets.SliderWidget")
	TextAreaWidget <<- J("org.rosuda.deducer.widgets.TextAreaWidget")
	ComboBoxWidget <<- J("org.rosuda.deducer.widgets.ComboBoxWidget")
	ListWidget <<- J("org.rosuda.deducer.widgets.ListWidget")
	TextFieldWidget <<- J("org.rosuda.deducer.widgets.TextFieldWidget")
	ObjectChooserWidget <<- J("org.rosuda.deducer.widgets.ObjectChooserWidget")
	
	RDialogMonitor <<- J("org.rosuda.deducer.widgets.RDialogMonitor")
	AddRemoveButtons <<- J("org.rosuda.deducer.widgets.AddRemoveButtons")
	
	JLabel <<- J("javax.swing.JLabel")
}

DeducerMain <- NULL

SimpleRDialog <- NULL
SimpleRSubDialog <- NULL
RDialog <- NULL

VariableSelectorWidget <- NULL
VariableListWidget <- NULL
CheckBoxesWidget <- NULL
ButtonGroupWidget <- NULL
SingleVariableWidget <- NULL
SliderWidget <- NULL
TextAreaWidget <- NULL
ComboBoxWidget <- NULL
ListWidget <- NULL
TextFieldWidget <- NULL
ObjectChooserWidget <- NULL
	
RDialogMonitor <- NULL
AddRemoveButtons <- NULL
	
JLabel <- NULL

.jgr <- NULL
.deducer <- NULL
.deducer.loaded <- NULL
.dialogs <- list()
.dialogGenerators <- NULL
.windowsGUI <- NULL
.vol <- new.env()
.jri.initialized <- FALSE

# Lazily initialize JRI's R engine on first GUI use, instead of in .onLoad.
# Why: JRI's Rengine static initializer calls System.loadLibrary("jri"), which
# JDK 17+ flags as a restricted native-access method. Deferring keeps R CMD
# check clean; the warning still fires interactively when a dialog opens.
.ensureJRI <- function(){
	if(.jri.initialized) return(TRUE)
	jriOK <- try(.jengine(TRUE), silent=TRUE)
	if(inherits(jriOK, "try-error")){
		warning("Unable to initialize JRI. Make sure R was built with shared libraries. The Java GUI will not be available.")
		return(FALSE)
	}
	if(bindingIsLocked(".jri.initialized", asNamespace("Deducer")))
		unlockBinding(".jri.initialized", asNamespace("Deducer"))
	.jri.initialized <<- TRUE
	TRUE
}

.runCmd <- function(name, threaded=FALSE){
	.ensureJRI()
	if(threaded)
		.jcall("org/rosuda/deducer/Deducer", , "runCmdThreaded", name)
	else
		.jcall("org/rosuda/deducer/Deducer", , "runCmd", name, TRUE)
}

.onAttach <- function(libname, pkgname){
	if(!is.null(.vol$.startupMsgs))
		packageStartupMessage(.vol$.startupMsgs)
}

.onLoad <- function(libname, pkgname) {

	# cli (loaded transitively via scales) treats JGR as an ANSI-capable
	# terminal because isatty(stdout()) returns TRUE. JGR's console doesn't
	# parse ANSI, so escape codes leak through as visible text:
	#   - "[?25h" after every prompt (from a task callback cli installs)
	#   - "[1m...[22m" / "[36m...[39m" in styled messages and warnings
	# Remove cli's cursor-show task callback and disable its colors/styles.
	if(requireNamespace("cli", quietly=TRUE)){
		pos <- tryCatch(get("task_callback", envir=asNamespace("cli")),
		                error=function(e) NULL)
		if(!is.null(pos))
			try(removeTaskCallback(pos), silent=TRUE)
		options(cli.num_colors = 1L)
		options(cli.dynamic = FALSE)
		options(cli.hyperlink = FALSE)
	}

	.imports <- parent.env(topenv())
	.i.par <- parent.env(.imports)
	
	#handle messages on .onAttach
	#ipe <- new.env(parent=.i.par)
	#attr(ipe, "name") <- "volatiles:Deducer"
	#parent.env(.imports) <- ipe
	#ipe$.startupMsgs <- NULL
	.vol$.startupMsg <- NULL
	startupMessage <- function(x){
		if(is.null(.vol$.startupMsgs))
			.vol$.startupMsgs <- x
		else
			.vol$.startupMsgs <- paste(.vol$.startupMsgs,x,sep="\n")
	}
	
	# Initialize the JVM. On Linux/macOS we pass --enable-native-access=
	# ALL-UNNAMED to suppress the JDK 17+ restricted-method warning that
	# JRI's Rengine.<clinit> trips, and seed the system classpath with
	# JRI.jar so RMainLoopCallbacks resolves before .jnew below loads
	# Deducer. On Windows we replicate 0.9-1's plain .jinit() so we do
	# not perturb the (working) eager .jengine(TRUE) path further down -
	# Windows JDKs and rJava versions in the wild have been finicky with
	# explicit classpath/params arguments here.
	jri_jar <- system.file("jri", "JRI.jar", package="rJava")
	if(.Platform$OS.type == "windows"){
		jriOK <- try(.jinit(), silent=TRUE)
	}else{
		jvm_params <- unique(c(getOption("java.parameters"),
		                       "--enable-native-access=ALL-UNNAMED"))
		jri_cp <- if(nzchar(jri_jar)) jri_jar else NULL
		jriOK <- try(.jinit(classpath = jri_cp, parameters = jvm_params),
		             silent=TRUE)
		if(inherits(jriOK, "try-error") || (is.numeric(jriOK) && jriOK < 0))
			jriOK <- try(.jinit(classpath = jri_cp), silent=TRUE)
	}

	.jgr <<- try(any(.jcall("java/lang/System","S","getProperty","main.class")=="org.rosuda.JGR.JGR"),silent=TRUE)
	if(class(.jgr) %in% "try-error"){
		startupMessage("\nNote: Problem initiating rJava. The Java GUI will not be available.\n")
		.deducer <<- .jnull()
		.deducer.loaded <<- TRUE
		.jgr <<-FALSE
		.windowsGUI <<- exists("winMenuAdd")
		return(TRUE)
	}
	

	if(!is.null(getOption("DeducerNoGUI")) && getOption("DeducerNoGUI")){
		startupMessage("\nLoading Deducer without GUI. If you wish the GUI to load, run options(DeducerNoGUI=FALSE) before loading Deducer\n")
		.deducer <<- .jnull()
		.deducer.loaded <<- TRUE
		.windowsGUI <<- exists("winMenuAdd")
		return(TRUE)
	}

	if (nzchar(Sys.getenv("NOAWT")) && .jgr!=TRUE) {
		startupMessage("\nNOTE: Environmental variable NOAWT set. Loading Deducer without GUI.\n")
		.deducer <<- .jnull()
		.deducer.loaded <<- TRUE
		.jgr <<-FALSE
		.windowsGUI <<- exists("winMenuAdd")
		return(TRUE)	
	}
	

	if(class(jriOK) %in% "try-error"){
		startupMessage("\nNote: Problem initiating JRI. The Java GUI will not be available.\n")
		#startupMessage(jriOK)
		.deducer <<- .jnull()
		.deducer.loaded <<- TRUE
		.jgr <<-FALSE
		.windowsGUI <<- exists("winMenuAdd")
		return(TRUE)
	}
	
	# On Linux/macOS the system classpath set by .jinit above is enough for
	# the JVM to resolve RMainLoopCallbacks when .jnew("Deducer") loads it.
	# On Windows that does not work (rJava's classloader does not propagate
	# to the verifier the way it does on POSIX), so we eagerly start JRI's
	# Rengine. That emits the JDK 17+ restricted-method warning, but
	# Hornik's CRAN check runs on Linux so the warning still does not appear
	# in the official check log.
	if(.Platform$OS.type == "windows"){
		try(.jengine(TRUE), silent=TRUE)
	}else if(nzchar(jri_jar)){
		.jaddClassPath(jri_jar)
	}
	.jpackage(pkgname,"deducer.jar",lib.loc=libname)
	.jpackage("JavaGD")
	.jpackage("JGR")
	
	.deducer<-try(.jnew("org/rosuda/deducer/Deducer",.jgr),silent=TRUE)
	if(inherits(.deducer, "try-error")){
		startupMessage("Note: Unable to start Deducer's Java class. The Java GUI will not be available.")
		.deducer <<- .jnull()
		.deducer.loaded <<- TRUE
		.windowsGUI <<- exists("winMenuAdd")
		return(TRUE)
	}
	.deducer <<- .deducer
	.deducer.loaded <<- TRUE
	.windowsGUI <<- FALSE
	

	
	if(exists("winMenuAdd")){
		temp<-try(utils::winMenuAdd("Deducer"),silent=TRUE)
		if(!inherits(temp, "try-error")){
			utils::winMenuAddItem("Deducer", "Open Data", "deducer('Open Data')")
			utils::winMenuAddItem("Deducer", "Save Data", "deducer('Save Data')")
			utils::winMenuAddItem("Deducer", "Data viewer", "deducer('Data viewer')")
			utils::winMenuAddItem("Deducer", "Deducer Online Help", "deducer('Deducer Online Help')")
			utils::winMenuAdd("Data")
			utils::winMenuAddItem("Data", "Edit Factor", "deducer('Edit Factor')")
			utils::winMenuAddItem("Data", "Recode Variables", "deducer('Recode Variables')")
			utils::winMenuAddItem("Data", "Transform", "deducer('Transform')")
			utils::winMenuAddItem("Data", "Reset Row Names", "deducer('Reset Row Names')")
			utils::winMenuAddItem("Data", "Sort", "deducer('Sort')")
			utils::winMenuAddItem("Data", "Transpose", "deducer('Transpose')")			
			utils::winMenuAddItem("Data", "Merge", "deducer('Merge')")
			utils::winMenuAddItem("Data", "Subset", "deducer('Subset')")
			utils::winMenuAddItem("Data", "Compute", "deducer('Compute')")
			utils::winMenuAdd("Analysis")
			utils::winMenuAddItem("Analysis", "Frequencies", "deducer('Frequencies')")
			utils::winMenuAddItem("Analysis", "Descriptives", "deducer('Descriptives')")
			utils::winMenuAddItem("Analysis", "Contingency Tables", "deducer('Contingency Tables')")
			utils::winMenuAddItem("Analysis", "One Sample Test", "deducer('One Sample Test')")
			utils::winMenuAddItem("Analysis", "Two Sample Test", "deducer('Two Sample Test')")
			utils::winMenuAddItem("Analysis", "K-Sample Test", "deducer('K-Sample Test')")
			utils::winMenuAddItem("Analysis", "Correlation", "deducer('Correlation')")
			utils::winMenuAddItem("Analysis", "Linear Model", "deducer('Linear Model')")
			utils::winMenuAddItem("Analysis", "Logistic Model", "deducer('Logistic Model')")
			utils::winMenuAddItem("Analysis", "Generalized Linear Model", "deducer('Generalized Linear Model')")
			utils::winMenuAdd("Plots")
			utils::winMenuAddItem("Plots", "Open plot", "deducer('Open plot')")
			utils::winMenuAddItem("Plots", "Plot builder", "deducer('Plot builder')")			
			startupMessage("\n\nDeducer has been loaded from within the Windows Rgui. 
				For the best experience, you are encouraged to use JGR console which can be
				downloaded from: http://jgr.markushelbig.org/\n")
			.windowsGUI <<- TRUE
		}else if(!.jgr || !.jcall("org/rosuda/deducer/Deducer", "Z", "isJGR") )
			startupMessage("\n\nNote Non-JGR console detected:\n\tDeducer is best used from within JGR (http://jgr.markushelbig.org/).
\tTo Bring up GUI dialogs, type deducer().\n")
	}else if(!.jgr || !.jcall("org/rosuda/deducer/Deducer", "Z", "isJGR") )
		startupMessage("\n\nNote Non-JGR console detected:\n\tDeducer is best used from within JGR (http://jgr.markushelbig.org/).
\tTo Bring up GUI dialogs, type deducer().\n")

	##sort of
	deducer.addMenu("File")
	deducer.addMenu("Data")
	deducer.addMenu("Analysis")
	deducer.addMenu("Plots")
	deducer.addMenu("Help")
	populate.items<-function(ch,cmds,men){
		for(i in 1:length(ch)){
			cmd <- sprintf("Deducer:::.runCmd(\"%s\", threaded=%s)", cmds[i], .jgr)
			deducer.addMenuItem(ch[i],,cmd,men)
		}
	}

	file.choices<-c("Open Data", "Save Data","Data viewer")
	file.cmds<-c("Open Data Set", "Save Data Set","table")
	populate.items(file.choices,file.cmds,"File")

	
	analysis.choices<-c("Frequencies","Descriptives",
				"Contingency Tables","One Sample Test","Paired Test","Two Sample Test",
				"K-Sample Test", "Correlation", "Linear Model", 
				"Logistic Model","Generalized Linear Model")
	analysis.cmds<-c("frequency","descriptives","contingency","onesample","pairedtest",
			"two sample","ksample","corr","linear", "logistic","glm")
	populate.items(analysis.choices,analysis.cmds,"Analysis")
	
	data.choices<-c("Edit Factor","Recode Variables","Transform",
			"Reset Row Names","Sort","Transpose","Merge",
			"Subset", "Compute")
	data.cmds<-c("factor","recode","transform","reset rows","sort","trans","merge","subset", "compute")
	populate.items(data.choices,data.cmds,"Data")
	
	plot.choices<-c("Open plot","Plot builder")
	plot.cmds<-c("Open plot", "plotbuilder")
	populate.items(plot.choices,plot.cmds,"Plots")
	
	help.choices<-c("Deducer Online Help")
	help.cmds<-c("dhelp")
	populate.items(help.choices,help.cmds,"Help")
	
	.dialogGenerators <<- list()
	.dialogs <<- list()


	.assign.classnames()

	.registerDialog("Interactive Scatter Plot", .makeIplotDialog)
	.registerDialog("Interactive Histogram", .makeIhistDialog)
	.registerDialog("Interactive Bar Plot", .makeIbarDialog)
	.registerDialog("Interactive Box Plot Long", .makeIboxLongDialog)
	.registerDialog("Interactive Box Plot Wide", .makeIboxWideDialog)
	.registerDialog("Interactive Mosaic Plot", .makeImosaicDialog)
	.registerDialog("Interactive Parallel Coordinate Plot", .makeIpcpDialog)
	.registerDialog("Paired Test", .makePairedTestDialog)

#	if(J("org.rosuda.deducer.toolkit.DeducerPrefs")$USEQUAQUACHOOSER && Sys.info()[1]=="Darwin")
#		.jChooserMacLAF()

} 
.onUnload <- function(libpath){
	# Only call the Java detach() if the JRI engine was actually started by a
	# GUI use this session. Otherwise (e.g. during R CMD check's namespace
	# unload test) JGR.MAINRCONSOLE is null and Deducer.detach() trips a
	# buffer overflow in JRI's native bridge that aborts R before try() can
	# catch it.
	if(isTRUE(.jri.initialized) &&
	   exists(".deducer") && exists(".deducer.loaded") && .deducer.loaded){
		try(.jcall(.deducer,"V","detach",silent=TRUE),silent=TRUE)
	}
}

deducer<-(function(){
	lastItem<-NULL
	deducer<-function(cmd=NULL){
		.ensureJRI()
		if(!.jfield("org/rosuda/deducer/Deducer","Z","started")){
			.jcall(.deducer,,"startNoJGR")
		}
		oldDevice<-getOption("device")
		options(device="JavaGD")
		
		menus<- deducer.getMenus()
		menuNames <- names(menus)
		
		if(!is.null(cmd)){
			for(m in menus){
				for(item in m$items){
					if(item$name == cmd){
						if(item$silent==TRUE){
							eval(parse(text=item$command),globalenv())
						}else{
							.deducerExecute(item$command)
						}
						lastItem<<-item
						options(device=oldDevice)
						return(invisible(NULL))
					}
				}
			}
			stop("Command not present in menus")
		}
		menuChoices<-menuNames
		if(!is.null(lastItem)){
			menuChoices <- c(menuChoices,paste("Last:",lastItem$name))
		}
		menuChoices <- c(menuChoices,"exit")
		m<-menu(menuChoices,,"Deducer")
		if(m == length(menuChoices)){
			options(device=oldDevice)
			return(invisible(NULL))
		}
		if(m == length(menuChoices)-1 && !is.null(lastItem)){
			item<-lastItem
			if(item$silent==TRUE){
				eval(parse(text=item$command),globalenv())
			}else{
				.deducerExecute(item$command)
			}
			options(device=oldDevice)
			return(invisible(NULL))
		}
		men <- menus[[m]]$items
		
		itemChoices<- c(sapply(men,function(x)x$name),"back")
		
		i <- menu(itemChoices,,names(menus)[m])
		if(i == length(itemChoices) || i<=0){
			options(device=oldDevice)
			deducer()
			return(invisible(NULL))
		}
		item <- men[[i]]
		lastItem<<-item
		if(item$silent==TRUE){
			eval(parse(text=item$command),globalenv())
		}else{
			.deducerExecute(item$command)
		}
		options(device=oldDevice)
		return(invisible(NULL))
	}
	deducer
})()


data.viewer<-function(){
	deducer("Data viewer")
}

##Recodes the variables of a data frame given a recoding specification
recode.variables<-function(data,recodes){
	recode.other<-function(var){
		if(is.factor(var)) stop("use recode.factor to recode factors")
		warning.flag<-TRUE
	    result <- var
		else.target<-""
		if(else.term!=""){
	        else.target <- eval(parse(text = strsplit(else.term, "->")[[1]][2]))
			result[1:length(var)] <- else.target
	    }
	    if(is.numeric(var)){
	        Lo <- min(var, na.rm = TRUE)
	        Hi <- max(var, na.rm = TRUE)
	    }else{
			Lo <-""
			Hi <-max(var, na.rm = TRUE)
		}
		for(term in recode.list){
			if(0 < length(grep(":", term))){
				if(is.character(var) && warning.flag){
					warning("Recoding a range of characters may not do what you think it does.\n Example: '15' is less than '9'.")
					warning.flag<-FALSE
				}
				range <- strsplit(strsplit(term, "->")[[1]][1], ":")
				low <- eval(parse(text = range[[1]][1]))
				high <- eval(parse(text = range[[1]][2]))
				if(high<low) next 
				target <- eval(parse(text = strsplit(term, "->")[[1]][2]))
				result[(var >= low) & (var <= high)] <- target
			}else{
				set <- eval(parse(text = strsplit(term, "->")[[1]][1]))
				target <- eval(parse(text = strsplit(term, "->")[[1]][2]))
		        for (val in set) {
					if (is.na(val)) 
				 		result[is.na(var)] <- target
		            else{ 
						result[var == val] <- target
					}	
				}
			}
		}
		return(result)
	}

	recode.factor<-function(var){
		if(!is.factor(var)) stop("var must be a factor")
		result<-var
		else.target<-""
		if(else.term!=""){
	        else.target <- eval(parse(text = strsplit(else.term, "->")[[1]][2]))
			if(!(else.target %in% levels(result))){
				levels(result)<-c(levels(result),else.target)
			}
			result<-factor(rep(else.target,length(var)),levels=else.target)
	    }

		for(term in recode.list){
			Lo<-levels(var)[1]
			Hi<-levels(var)[length(levels(var))]
			if(0 < length(grep(":", term))){
				range <- strsplit(strsplit(term, "->")[[1]][1], ":")
				low <- eval(parse(text = range[[1]][1]))
				low<-which(levels(var)==low)[1]
				if(is.na(low)) stop(paste("Lower value in range not a valid factor level.",term))
				high <- eval(parse(text = range[[1]][2]))
				high <- which(levels(var)==high)[1]
				if(is.na(high)) stop(paste("upper value in range not a valid factor level.",term))
				if(high<low) stop(paste("Upper value must be ordered after lower value in the factor ordering.",term))
	
				target <- eval(parse(text = strsplit(term, "->")[[1]][2]))
				set<-levels(var)[low:high]
				if(!(target %in% levels(result))){
					levels(result)<-c(levels(result),target)	
				}
				result[var %in% set] <- target
				set<-setdiff(set,target)
				levels(result)<-ifelse(levels(result) %in% set,NA,levels(result))
			}else{
				set <- eval(parse(text = strsplit(term, "->")[[1]][1]))
				target <- eval(parse(text = strsplit(term, "->")[[1]][2]))
		        for (val in set) {
					if(!(target %in% levels(result))){
						levels(result)<-c(levels(result),target)
					}
					if (is.na(val)) 
				 		result[is.na(var)] <- target
		            else{ 
						result[var == val] <- target
						if (!is.na(val) && !is.na(target) && val != target){
							levels(result)<-ifelse(levels(result)==val,NA,levels(result))
						}
					}	
				}
			}
		}
		return(result)
	}

	if(!is.data.frame(data)) data<-as.data.frame(data)
	recode.list <- strsplit(recodes, ";")[[1]]
	else.term<-""
	else.ind<-c()
	for(i in 1:length(recode.list)){
		first.part<-strsplit(recode.list[[i]],"->")[[1]][1]
		if(length(grep("else",first.part))>0 && length(grep("'",first.part))<1){
			else.term<-recode.list[[i]]
			else.ind<-c(else.ind,-i)
		}
	}
	if(length(else.ind)>0) recode.list<-recode.list[else.ind]	
	result.data<-data.frame(1:dim(data)[1])
	for(variable in data){
		if(is.factor(variable)){
			result.data<-data.frame(result.data,recode.factor(variable),stringsAsFactors=FALSE)
		}else result.data<-data.frame(result.data,recode.other(variable),stringsAsFactors=FALSE)
	}
	return(result.data[-1])
} 

##Corrected the formulas from M.J. Smithson
##http://psychology.anu.edu.au/people/smithson/details/CIstuff/CI.html
chi.noncentral.conf<-function (chival, df, conf, prec = 1e-05) 
{
	result <- NA
	ulim <- 1 - (1 - conf)/2
	lc <- c(0.001, chival/2, chival)
	while (pchisq(chival, df, lc[1]) < ulim) {
		if (pchisq(chival, df) < ulim) {
			result <- (c(0, pchisq(chival, df)))
			break
		}
		lc <- c(lc[1]/4, lc[1], lc[3])
	}
	diff <- 1
	if (all(is.na(result))) {
		while (diff > prec) {
			if (pchisq(chival, df, lc[2]) < ulim) 
				lc <- c(lc[1], (lc[1] + lc[2])/2, lc[2])
			else lc <- c(lc[2], (lc[2] + lc[3])/2, lc[3])
			diff <- abs(pchisq(chival, df, lc[2]) - ulim)
			ucdf <- pchisq(chival, df, lc[2])
		}
		result <- c(lc[2], ucdf)
	}
	uc <- c(chival, 2 * chival, 3 * chival)
	llim <- (1 - conf)/2

	while (pchisq(chival, df, uc[1]) < llim && uc>prec) {
		uc <- c(uc[1]/4, uc[1], uc[3])
	}
	while (pchisq(chival, df, uc[3]) > llim) {
		uc <- c(uc[1], uc[3], uc[3] + chival)
	}
	diff <- 1
	count<-0
	while (diff > prec) {
		if (pchisq(chival, df, uc[2]) < llim) 
			uc <- c(uc[1], (uc[1] + uc[2])/2, uc[2])
		else uc <- c(uc[2], (uc[2] + uc[3])/2, uc[3])
		diff <- abs(pchisq(chival, df, uc[2]) - llim)
		lcdf <- pchisq(chival, df, uc[2])
		count<-count+1
		if(count>1000){
			warning("Convergence not reached in chi.noncentral.conf .")
			uc[2]<-Inf
			lcdf<-0
			break
		}
	}
	result <- rbind(result, c(uc[2], lcdf))
	rownames(result) <- c("Lower", "Upper")
	colnames(result) <- c("Non-Central", "%")
	result
}



#Adapted from
# g.test V3.3 Pete Hurd Sept 29 2001. phurd@ualberta.ca
likelihood.test <- function(x, y = NULL, conservative=FALSE)
{
	DNAME <- deparse(substitute(x))
	if (is.data.frame(x)) x <- as.matrix(x)
	if (is.matrix(x)) {
		if (min(dim(x)) == 1) 
		x <- as.vector(x)
	}
	if (!is.matrix(x) && !is.null(y)) {
		if (length(x) != length(y)) 
			stop("x and y must have the same length")
		DNAME <- paste(DNAME, "and", deparse(substitute(y)))
		OK <- complete.cases(x, y)
		x <- as.factor(x[OK])
		y <- as.factor(y[OK])
		if ((nlevels(x) < 2) || (nlevels(y) < 2)) 
			stop("x and y must have at least 2 levels")
		x <- table(x, y)
	}
	if (any(x < 0) || any(is.na(x))) 
		stop("all entries of x must be nonnegative and finite")
	if ((n <- sum(x)) == 0) 
		stop("at least one entry of x must be positive")

	if (!is.matrix(x))
		stop("Could not make a 2-dimensional matrix")
		
		
	#Test of Independence
	nrows<-nrow(x)
	ncols<-ncol(x)

	sr <- apply(x,1,sum)
	sc <- apply(x,2,sum)
	E <- outer(sr,sc, "*")/n

	# no monte-carlo
	# calculate G
	g <- 0
	for (i in 1:nrows){
		for (j in 1:ncols){
			if (x[i,j] != 0) g <- g + x[i,j] * log(x[i,j]/E[i,j])
		}
	}
	q <- 1
	if (conservative){ # Do Williams correction
		row.tot <- col.tot <- 0    
		for (i in 1:nrows){ row.tot <- row.tot + 1/(sum(x[i,])) }
		for (j in 1:ncols){ col.tot <- col.tot + 1/(sum(x[,j])) }
		q <- 1+ ((n*row.tot-1)*(n*col.tot-1))/(6*n*(ncols-1)*(nrows-1))
	}
	STATISTIC <- G <- 2 * g / q
	PARAMETER <- (nrow(x)-1)*(ncol(x)-1)
	PVAL <- 1-pchisq(STATISTIC,df=PARAMETER)
	if(!conservative)
		METHOD <- "Log likelihood ratio (G-test) test of independence without correction"
	else
		METHOD <- "Log likelihood ratio (G-test) test of independence with Williams' correction"

	names(STATISTIC) <- "Log likelihood ratio statistic (G)"
	names(PARAMETER) <- "X-squared df"
	names(PVAL) <- "p.value"
	structure(list(statistic=STATISTIC,parameter=PARAMETER,p.value=PVAL,
		method=METHOD,data.name=DNAME, observed=x, expected=E),
		class="htest")
}





print.contin.table<-function(x,digits=3,prop.r=TRUE,prop.c=TRUE,prop.t=TRUE,
						expected.n=FALSE,residuals=FALSE,std.residuals=FALSE,adj.residuals=FALSE,no.tables=FALSE,...){
	tab<-x
	for(index in 1:length(tab)){
		if(!inherits(tab[[index]], "single.table")){
			print(tab[[index]],...)
			next
		}else if(no.tables)
			next

		ColTotal <- "Column Total"
    	RowTotal <- "Row Total"
		t<-tab[[index]]$table
		RS<-tab[[index]]$row.sums
		CS<-tab[[index]]$col.sums
		CPR<-tab[[index]]$row.prop
		CPC<-tab[[index]]$col.prop
		CPT<-tab[[index]]$total.prop
		GT<-tab[[index]]$total
		expected<-tab[[index]]$expected
		ASR <- (t - expected)/sqrt(expected * 
            ((1 - RS/GT) %*% t(1 - CS/GT)))
		StdR<-(t - expected)/sqrt(expected)
		RTitleMargin<-10
    	CWidth <- max(digits + 4, c(nchar(t), nchar(dimnames(t)[[2]]), 
    	    nchar(RS), nchar(CS), nchar(RowTotal)))
		RWidth <- max(c(nchar(dimnames(t)[[1]]), nchar(ColTotal)))
		RWidth <- RWidth+RTitleMargin
    	RowSep <- paste(rep("-", CWidth + 2), collapse = "")
    	RowSep1 <- paste(rep("-", RWidth + 1), collapse = "")
    	SpaceSep1 <- paste(rep(" ", RWidth-RTitleMargin), collapse = "")
    	SpaceSep2 <- paste(rep(" ", CWidth), collapse = "")
		FirstCol <- formatC(paste(dimnames(t)[[1]]," Count   "), width = RWidth, format = "s")
    	ColTotal <- formatC(ColTotal, width = RWidth, format = "s")
    	RowTotal <- formatC(RowTotal, width = CWidth, format = "s")
		RowData<-names(dimnames(t))[1]
		ColData<-names(dimnames(t))[2]
		if(names(tab)[index]!="No Strata")
			cat(paste("\n",SpaceSep1,"           | -- ",sep="",collapse=""),"Stratum = ",
				names(tab)[index]," --", "\n",sep="")
    	out<-capture.output(cat(paste(SpaceSep1,"          ",sep="",collapse=""), "|", ColData, "\n"))
   		out<-c(out,capture.output(cat(cat(formatC(substr(RowData,0,RWidth-1), width = RWidth, format = "s"), 
    					sep = " | ", collapse = ""), cat(formatC(dimnames(t)[[2]], 
    					width = CWidth - 1, format = "s"), sep = "  | ", 
    					collapse = ""), cat(RowTotal, sep = " | ", collapse = "\n"), 
    					sep = "", collapse = "")))
    	out<-c(out,capture.output(cat(RowSep1, rep(RowSep, ncol(t) + 1), sep = "|", collapse = "\n")))
    	for (i in 1:nrow(t)) {
			out<-c(out,capture.output(cat(cat(FirstCol[i], sep = " | ", collapse = ""), 
    					cat(formatC(c(t[i, ], RS[i]), width = CWidth - 
    					1, format = "d"), sep = "  | ", collapse = "\n"), 
    					sep = "", collapse = "")))
    	    if (prop.r) 
				out<-c(out,capture.output(cat(cat(paste(SpaceSep1," Row %   "), sep = " | ", collapse = ""), 
    	        		cat(formatC(c(CPR[i, ] * 100, 100 * RS[i]/GT), 
    	            	width = CWidth - 1, digits = digits, format = "f"), 
        	        	sep = "% | ", collapse = "\n"), sep = "", 
       	         		collapse = "")))
	       	if (prop.c) 
				out<-c(out,capture.output(cat(cat(paste(SpaceSep1," Column %"), sep = " | ", collapse = ""), 
							cat(formatC(CPC[i, ] * 100, width = CWidth - 
							1, digits = digits, format = "f"), sep = "% | ", 
							collapse = ""), cat(SpaceSep2, sep = " | ", 
							collapse = "\n"), sep = "", collapse = "")))
	        if (prop.t) 
				out<-c(out,capture.output(cat(cat(paste(SpaceSep1," Total % "), sep = " | ", collapse = ""), 
							cat(formatC(CPT[i, ] * 100, width = CWidth - 
							1, digits = digits, format = "f"), sep = "% | ", 
							collapse = ""), cat(SpaceSep2, sep = " | ", 
							collapse = "\n"), sep = "", collapse = "")))
	        if (expected.n) 
				out<-c(out,capture.output(cat(cat(paste(SpaceSep1," Expected"), sep = " | ", collapse = ""), 
							cat(formatC(expected[i, ], digits = digits, 
							format = "f", width = CWidth - 1), sep = "  | ", 
							collapse = ""), cat(SpaceSep2, sep = " | ", 
							collapse = "\n"), sep = "", collapse = "")))
	        if (residuals) 
				out<-c(out,capture.output(cat(cat(paste(SpaceSep1," Residual"), sep = " | ", collapse = ""), 
							cat(formatC(t[i,]-expected[i, ], digits = digits, 
							format = "f", width = CWidth - 1), sep = "  | ", 
							collapse = ""), cat(SpaceSep2, sep = " | ", 
							collapse = "\n"), sep = "", collapse = "")))
	        if (adj.residuals)
				out<-c(out,capture.output(cat(cat(paste(SpaceSep1,"Adj Resid"), sep = " | ", collapse = ""), 
							cat(formatC(ASR[i,], digits = digits, 
							format = "f", width = CWidth - 1), sep = "  | ", 
							collapse = ""), cat(SpaceSep2, sep = " | ", 
							collapse = "\n"), sep = "", collapse = "")))
	        if (std.residuals)
				out<-c(out,capture.output(cat(cat(paste(SpaceSep1,"Std Resid"), sep = " | ", collapse = ""), 
							cat(formatC(StdR[i,], digits = digits, 
							format = "f", width = CWidth - 1), sep = "  | ", 
							collapse = ""), cat(SpaceSep2, sep = " | ", 
							collapse = "\n"), sep = "", collapse = "")))
	        out<-c(out,capture.output(cat(RowSep1, rep(RowSep, ncol(t) + 1), sep = "|", 
	            		collapse = "\n")))
		}
		out<-c(out,capture.output(cat(cat(ColTotal, sep = " | ", collapse = ""), cat(formatC(c(CS, 
	    				GT), width = CWidth - 1, format = "d"), sep = "  | ", 
	    				collapse = "\n"), sep = "", collapse = "")))
		if(prop.c)
	        out<-c(out,capture.output(cat(cat(paste(SpaceSep1," Column %"), sep = " | ", collapse = ""), 
						cat(formatC(CS/GT * 100, width = CWidth - 
						1, digits = digits, format = "f"), sep = "% | ", 
						collapse = ""), cat(SpaceSep2, sep = " | ", 
						collapse = "\n"), sep = "", collapse = "")))
		ConsoleWidth<-getOption("width")
		printOut<-function(StartingCharPos){
			FirstWidth<-nchar(FirstCol[1])+2
			ColWidth<-CWidth+3
			NCol<-length(lapply(strsplit(out[6],"|",fixed=TRUE),nchar)[[1]])-2
			WorkingNCol<-(ConsoleWidth-FirstWidth-1)%/%ColWidth
			for(i in 1:length(out)){
				cat(substr(out[i],0,FirstWidth),substr(out[i],
					StartingCharPos+FirstWidth,StartingCharPos+FirstWidth+WorkingNCol*ColWidth),
					"\n",sep="")
			}
			if((StartingCharPos+FirstWidth+WorkingNCol*ColWidth)<=(nchar(out[6])-1)){
				cat("\n",sep="")
				printOut(StartingCharPos+WorkingNCol*ColWidth)
			}
		}
		printOut(1)
	}
}

extract.counts<-function(tables){
	result<-list()
	for(j in 1:length(tables)){
		table<-tables[[j]]
		table.list<-lapply(table,function(x) if(inherits(x,"single.table")) x$table)
		table.list<-table.list[sapply(table.list,function(x) !is.null(x))]
		len<-length(table.list)
		rownam<-c()
		colnam<-c()
		for(i in 1:len){
			rownam<-union(rownam,rownames(table.list[[i]]))
			colnam<-union(colnam,colnames(table.list[[i]]))
		}
		ary<-array(0,c(length(rownam),length(colnam),len),list(rownam,colnam,names(table.list)))
		for(i in 1:len){
			ary[rownames(table.list[[i]]),colnames(table.list[[i]]),i]<-table.list[[i]]
		}
		result[[names(tables)[j]]]<-ary
	}
	result
}


add.cross.strata.test<-function(tables,name,htests,types=c("asymptotic","monte.carlo","exact")){
	types<-match.arg(types,c("asymptotic","monte.carlo","exact"),TRUE)
	if(is.function(htests))
		htests<-list(htests)
	if(length(htests)!=length(types))
		stop("type and tests must be the same length")
	if(!inherits(tables,"contingency.tables"))
		stop("tables is not a contingency.tables object")

	count.tables<-extract.counts(tables)
	for(i in 1:length(tables)){
		if(!inherits(tables[[i]], "contin.table"))
			next
		tests<-list(stratum = "Cross Strata",
							asymptotic=if("asymptotic" %in% types) 
											htests[[which(types=="asymptotic")]](count.tables[[names(tables)[i]]]) 
										else NA,
							monte.carlo=if("monte.carlo" %in% types) 
											htests[[which(types=="monte.carlo")]](count.tables[[names(tables)[i]]]) 
										else NA,
							exact=if("exact" %in% types) 
											htests[[which(types=="exact")]](count.tables[[names(tables)[i]]]) 
										else NA)
		tests<-tests[!is.na(tests)]
		test.l<-list(tests)
		if(is.null(tables[[i]]$cross.strata.tests)){
				tables[[i]]$cross.strata.tests<-list()
				class(tables[[i]]$cross.strata.tests)<-"contin.tests"
		}
		tables[[i]]$cross.strata.tests[name]<-list(test.l)
	}
	tables
}

add.mantel.haenszel<-function(tables,conservative=FALSE){
	add.cross.strata.test(tables,"Mantel-Haenszel",list(function(x) mantelhaen.test(x,correct=conservative)),"asymptotic")
}


add.test<-function(tables,name,htests,types=c("asymptotic","monte.carlo","exact")){
	
	types<-match.arg(types,c("asymptotic","monte.carlo","exact"),TRUE)
	if(is.function(htests))
		htests<-list(htests)
	if(length(htests)!=length(types))
		stop("type and tests must be the same length")
	if(!inherits(tables,"contingency.tables"))
		stop("tables is not a contingency.tables object")
	for(i in 1:length(tables)){
		if(!inherits(tables[[i]],"contin.table"))
			next
		tests<-list()
		for(j in 1:length(tables[[i]])){
			tab<-tables[[i]]
			if(!inherits(tab[[j]],"single.table"))
				next
			tests[[j]]<-list(stratum = names(tab)[j],
								asymptotic=if("asymptotic" %in% types) 
												try(htests[[which(types=="asymptotic")]](tab[[j]]$table))
											else NA,
								monte.carlo=if("monte.carlo" %in% types) 
												try(htests[[which(types=="monte.carlo")]](tab[[j]]$table)) 
											else NA,
								exact=if("exact" %in% types) 
												try(htests[[which(types=="exact")]](tab[[j]]$table))
											else NA)
			tests[[j]]<-tests[[j]][!is.na(tests[[j]])]
			invalid<-sapply(tests[[j]],function(x) inherits(x,"try-error"))
			htestNA<-structure(list(statistic = NA, parameter = NA, 
        		p.value = NA, method = "", data.name = ""), class = "htest")
        	for(index in 1:length(tests[[j]]))
        		if(invalid[index])
					tests[[j]][[index]]<-htestNA
			
		}
		test.l<-list(tests)
		if(is.null(tables[[i]]$tests)){
				tables[[i]]$tests<-list()
				class(tables[[i]]$tests)<-"contin.tests"
		}
		tables[[i]]$tests[name]<-test.l
	}
	tables	
}

add.chi.squared<-function(tables, simulate.p.value = FALSE, B = 10000){


	if(simulate.p.value){
		chi.func<-list(function(x) chisq.test(x, correct=FALSE),
						function(x) chisq.test(x,simulate.p.value=TRUE,B=B))
		types<-c("asymptotic","monte.carlo")
	}else{
		chi.func<-list(function(x) chisq.test(x, correct=FALSE))
		types<-c("asymptotic")
	}
	add.test(tables,"Chi Squared",chi.func,types)
}

add.likelihood.ratio<-function(tables, conservative = FALSE, simulate.p.value = FALSE, B = 10000){

	if(simulate.p.value)
		warning("monte carlo not yet implemented")
	add.test(tables,paste(c("Likelihood",if(conservative) "(conservative)" else ""),collapse="")
					,function(x) likelihood.test(x,,conservative),"asymptotic")
}

add.fishers.exact<-function(tables,  simulate.p.value = FALSE, B = 10000){
	add.test(tables,"Fishers Exact"
					,function(x) {
	tst <- fisher.test(x,simulate.p.value=simulate.p.value,B=B)
	tst$statistic <- NA
	tst$parameter <- NA
	tst
	},"exact")	
}

add.correlation<-function(tables,method=c("spearman","kendall")){
	method<-match.arg(method)
	corr<-function(x) {
		colnames(x) <- 1:ncol(x)
		rownames(x) <- 1:nrow(x)
		tmp<-table.to.data(x)
		test<-cor.test(as.numeric(as.character(tmp[[1]])),as.numeric(as.character(tmp[[2]])),exact=FALSE,method=method)
		if(is.null(test$parameter))
			test$parameter<-NA
		if(is.null(test$conf.int))
			test$conf.int<-c(NA,NA)
		test
	}
	add.test(tables,paste(c(method,"'s Correlation"),collapse=""),
					corr,
					"asymptotic")
}

add.kruskal<-function(tables,nominal=c("both","rows","cols")){
	nominal<-match.arg(nominal)
	krusk.rows<-function(x) {
		tmp<-table.to.data(x)
		test<-kruskal.test(tmp[[2]],tmp[[1]])
		test
	}
	krusk.cols<-function(x) {
		tmp<-table.to.data(x)
		test<-kruskal.test(tmp[[1]],tmp[[2]])
		test
	}
	if(nominal %in% c("rows","both"))
		tables<-add.test(tables,"Kruskal-W (nominal rows)",
					krusk.rows,
					"asymptotic")
	if(nominal %in% c("cols","both"))
		tables<-add.test(tables,"Kruskal-W (nominal cols)",
					krusk.cols,
					"asymptotic")
	tables
}



contin.tests.to.table<-function(tests,test.digits=3,...){
	if(!inherits(tests,"contin.tests"))
		stop("tests are not of class contin.tests")
	cat("\n\n\n",sep="")
	any.mc<-any(sapply(tests , function(test) sapply(test, function(x) !is.null(x$monte.carlo))))
	any.exact<-any(sapply(tests , function(test) sapply(test, function(x) !is.null(x$exact))))
	any.a<-any(sapply(tests , function(test) sapply(test, function(x) !is.null(x$asymptotic))))
	any.aest<-any(sapply(tests , function(test) sapply(test,
					function(x) sapply(x[c("asymptotic")], 
					function(y) {!is.null(y) && !is.null(y$estimate)&& !is.na(y$estimate)}))))
	n.col<-0
	if(any.a){
		n.col<-3
		est.start<-NULL
		if(any.aest){
			aest.div<-n.col+1
			aest.start<-n.col+2
			n.col<-n.col+5
		}
	}
	if(any.mc){
		mc.div<-n.col+1
		mc.start<-n.col+2	
		n.col<-n.col+4
	}
	if(any.exact){
		exact.div<-n.col+1
		exact.start<-n.col+2
		n.col<-n.col+4
	}

	n.tests<-length(tests)*max(sapply(tests,function(test) length(test)))
	table.form<-as.table(matrix(NA,ncol=n.col,nrow=n.tests+1))
	rownames(table.form)[1]<-"Test"
	for(test.index in 1:length(tests)){
		for(stratum.index in 1:length(tests[[test.index]])){
			row.index<-test.index+length(tests)*(stratum.index-1)+1
			test.list<-tests[[test.index]][[stratum.index]]
			if(test.index==1 && test.list$stratum!="No Strata" && test.list$stratum!="Cross Strata"){
				rownames(table.form)[row.index]<-paste(
									c("Stratum =",test.list$stratum,"  ",
									names(tests)[[test.index]]),collapse=" ")
			}else
				rownames(table.form)[row.index]<-names(tests)[[test.index]]
			if(!is.null(test.list$asymptotic)){
				table.form[row.index,1]<-round(test.list$asymptotic$statistic,test.digits)
				table.form[row.index,2]<-round(test.list$asymptotic$parameter,test.digits)
				table.form[row.index,3]<-round(test.list$asymptotic$p.value,test.digits)
			
				if(is.finite(table.form[row.index,3]) && table.form[row.index,3]<10^(-test.digits))
					table.form[row.index,3]<-paste(c("<0.",rep("0",test.digits-1),"1"),collapse="")
			}
			if(!is.null(test.list$monte.carlo)){
				table.form[row.index,mc.start]<-round(test.list$monte.carlo$statistic,test.digits)
				table.form[row.index,mc.start+1]<-round(test.list$monte.carlo$parameter,test.digits)
				table.form[row.index,mc.start+2]<-round(test.list$monte.carlo$p.value,test.digits)		
				if(is.finite(table.form[row.index,mc.start+2]) && 
						table.form[row.index,mc.start+2]<(10^-test.digits))
					table.form[row.index,mc.start+2]<-paste(c("<0.",rep("0",test.digits-1),"1"),
																collapse="")	
			}
			if(!is.null(test.list$exact)){
				table.form[row.index,exact.start]<-round(test.list$exact$statistic,test.digits)
				table.form[row.index,exact.start+1]<-round(test.list$exact$parameter,test.digits)
				table.form[row.index,exact.start+2]<-round(test.list$exact$p.value,test.digits)		
				if(is.finite(table.form[row.index,exact.start+2]) && 
						table.form[row.index,exact.start+2]<(10^-test.digits))
					table.form[row.index,exact.start+2]<-paste(c("<0.",rep("0",test.digits-1),"1"),
																collapse="")	
			}
			if(!is.null(test.list$asymptotic$estimate) && !is.null(names(test.list$asymptotic$estimate))){
				test<- test.list$asymptotic
				lim<-names(test$conf.int)
				table.form[row.index,aest.start]<-names(test$estimate)
				table.form[row.index,aest.start+1]<-round(test$estimate,test.digits)
				if(!is.null(test$conf.int)){
					if(!is.na(test$conf.int[1]))
						table.form[row.index,aest.start+2]<-paste(c(round(test$conf.int[1],test.digits)," (",
														as.numeric(lim[1])*100,")"),collapse="")
					if(!is.na(test$conf.int[1]))	
						table.form[row.index,aest.start+3]<-paste(c(round(test$conf.int[2],test.digits)," (",
														as.numeric(lim[2])*100,")"),collapse="")
				}
			}
		}
	}
	if(any.a){
		colnames(table.form)[1:3]<-c("Large Sample","","")
		table.form[1,1:3]<-c("Statistic","DF","p-value")
	}
	if(any.mc){
		colnames(table.form)[mc.start:(mc.start+2)]<-c("Monte Carlo","","")
		colnames(table.form)[mc.div]<-"|"
		table.form[1,mc.start:(mc.start+2)]<-c("Statistic","DF","p-value")
		table.form[,mc.div]<-"|"
	}
	if(any.exact){
		colnames(table.form)[exact.start:(exact.start+2)]<-c("Exact","","")
		colnames(table.form)[exact.div]<-"|"
		table.form[1,exact.start:(exact.start+2)]<-c("Statistic","DF","p-value")
		table.form[,exact.div]<-"|"
	}
	if(any.aest){
		table.form[1,aest.start:(aest.start+3)]<-c("Effect Size","est.","Lower (%)","Upper (%)")
		colnames(table.form)[c(aest.div,aest.start:(aest.start+3))]<-""
		table.form[,aest.div]<-"|"
	}
	
	rownames(table.form)<-formatC(rownames(table.form),width=max(nchar(rownames(table.form))))
	
	table.form
}

print.contin.tests<-function(x,test.digits=3,...){
	tests<-x
	class(tests)<-"contin.tests"
	table.form<-contin.tests.to.table(tests,test.digits,...)
	div<-which(colnames(table.form)=="|")
	div<-c(div,dim(table.form)[2]+1)
	if(dim(table.form)[2]<=7){
		print(table.form)
	}else{
		start.ind<-1
		if(div[1]==1)
			div<-div[-1]
		for(ind in div){
			tmp<-table.form[,start.ind:(ind-1)]
			print(as.table(tmp))
			cat(rep("-",nchar(rownames(tmp)[1])),"\n",sep="")
			start.ind<-ind+1
		}
	}
cat("\n\n\n")
}


contingency.tables<-function (row.vars, col.vars,stratum.var, data=NULL, missing.include=FALSE ) {
	arguments <- as.list(match.call()[-1])
	if(missing(row.vars) || missing(col.vars))
		stop("Please specify the row variables (row.vars), and column variables (col.vars)")
	row.vars <- eval(substitute(row.vars),data, parent.frame())
	col.vars <- eval(substitute(col.vars),data, parent.frame())
	if(length(dim(row.vars))<1.5){
		row.vars <- as.data.frame(row.vars)
		names(row.vars) <- as.character(arguments$row.vars)
	}
	if(length(dim(col.vars))<1.5){
		col.vars<-as.data.frame(col.vars)
		names(col.vars) <- as.character(arguments$col.vars)
	}
	
	#print(row.vars)
	if(!missing(stratum.var))
		stratum.var<-eval(substitute(stratum.var),data, parent.frame())
	else
		stratum.var<-NULL
    vector.x <- FALSE
	num.row.vars<-dim(row.vars)[2]
	num.col.vars<-dim(col.vars)[2]


	##takes a dataframe whose first two column are the row and column vectors for the table.
	##optionally a third column indicates stratum
	single.table<-function(dat,dnn){
		x<-dat[[1]]
		y<-dat[[2]]
		if(is.null(stratum.var))
			stratum.var<-rep("No Strata",length(x))
        if (length(x) != length(y)) 
            stop("all row.vars and col.vars must have the same length")
        if (missing.include) {
            x <- factor(x, exclude = c())
            y <- factor(y, exclude = c())
			strata <- factor(stratum.var, exclude = c())
        }
        else {
            x <- factor(x)
            y <- factor(y)
			strata <- factor(stratum.var)
        }
		lev<-levels(strata)
		table.list<-list()
		for(level in lev){
			temp.x<-x[strata==level]
			temp.y<-y[strata==level]
        	t <- table(temp.x, temp.y,dnn=dnn)
    		RS <- rowSums(t)
    		CS <- colSums(t)
			t<-t[RS>0,CS>0,drop=FALSE]
    		RS <- rowSums(t)
    		CS <- colSums(t)
    		CPR <- prop.table(t, 1)
    		CPC <- prop.table(t, 2)
    		CPT <- prop.table(t)
			CST <- try(suppressWarnings(chisq.test(t, correct = FALSE)),silent=TRUE)
			if(!inherits(CST,"htest"))
				CST<-list(expected=t*NA)
    		GT <- sum(t)
    		if (length(dim(x) == 2)) 
        		TotalN <- GT
    		else TotalN <- length(temp.x)
			table.list[[level]]<-list(table=t,row.sums=RS,col.sums=CS,
										total=GT,row.prop=CPR,col.prop=CPC,total.prop=CPT,
										expected=CST$expected)
			class(table.list[[level]])<-"single.table"
		}
		class(table.list)<-"contin.table"
		table.list
	}
	result<-list()
	count<-1;
	for(i in 1:num.row.vars){
		for(j in 1:num.col.vars){
			result[[paste(names(row.vars)[i],"by",names(col.vars)[j])]]<-single.table(
						data.frame(row.vars[,i],col.vars[,j]),
								dnn=c(names(row.vars)[i],names(col.vars)[j]))
			count<-count+1
		}
	}
	class(result)<-"contingency.tables"
	result
}

print.contingency.tables<-function(x,digits=3,prop.r=TRUE,prop.c=TRUE,prop.t=TRUE,expected.n=FALSE,no.tables=FALSE,...){
	tables<-x
	ConsoleWidth<-getOption("width")
	MainSep<-paste(rep("=",ConsoleWidth),collapse="")
	SubSep<-paste(c(rep(" ",15),rep("=",ConsoleWidth-30),rep(" ",15)),collapse="")
	cat(MainSep,"\n",sep="")
	cat("\n",sep="")
	for(i in 1:length(tables)){
		cat(SubSep,"\n",sep="")
		name<-paste(c("Table: ",names(tables)[i]),collapse="")
		len<-nchar(name)+2
		space<-floor((ConsoleWidth-len)/2)
		cat(paste(rep(" ",max(0,space-10)),collapse=""),paste(rep("=",10),collapse="")," ",name,
			" ",paste(rep("=",10),collapse=""),paste(rep(" ",max(0,space-10)),collapse=""),"\n",sep="")
		print(tables[[i]],digits,prop.r,prop.c,prop.t,expected.n,no.tables=no.tables,...)
		cat("\n",sep="")
	}
	cat("\n",MainSep,"\n",sep="")
}

ggcorplot <- function(cor.mat,data=NULL,lines=TRUE,line.method=c("lm","loess"),type="points",
		alpha=.25,main="auto",var_text_size=5,
		cor_text_limits=c(5,25),level=.05){
	x_var <- y_var <- trans <- rsq <- p <- x_label <- NULL
	#define a helper function (borrowed from the "ez" package)
	ezLev<-function(x,new_order){
		for(i in rev(new_order)){
			x<-relevel(x,ref=i)
		}
		return(x)
	}							
	
	if(all(line.method==c("lm","loess")))
		line.method<-"lm"	
	
	nm <- names(cor.mat)
	for(i in 1:length(nm))
		dat <- if(i==1) d(eval(parse(text=nm[i]),data,parent.frame())) else d(dat, eval(parse(text=nm[i]),data,parent.frame()))
	data <- dat
	names(data) <- nm
	# normalize data
	for(i in 1:length(data)){
		data[,i]<-as.numeric(data[,i])
		data[,i]<-(data[,i]-mean(data[,i],na.rm=TRUE))/sd(data[,i],na.rm=TRUE)
	}
	# obtain new data frame
	z<-data.frame()
	i <- 1
	j <- i
	while(i<=length(data)){
		if(j>length(data)){
			i<-i+1
			j<-i
		}else{
			x <- data[,i]
			y <- data[,j]
			temp<-as.data.frame((cbind(x,y)))
			temp<-cbind(temp,names(data)[i],names(data)[j])
			z<-rbind(z,temp)
			
			j<-j+1
		}
	}
	z<-cbind(z,alpha)
	names(z)=c('x_var','y_var','x_label','y_label','trans')
	z$x_label <- ezLev(factor(z$x_label),names(data))
	z$y_label <- ezLev(factor(z$y_label),names(data))
	z=z[z$x_label!=z$y_label,]
	#obtain correlation values
	z_cor <- data.frame()
	i <- 1
	j <- i
	while(i<=length(data)){
		if(j>length(data)){
			i<-i+1
			j<-i
		}else{
			x <- na.omit(data[,i])
			y <- na.omit(data[,j])
			x_mid <- min(x)+diff(range(x))/2
			y_mid <- min(y)+diff(range(y))/2
			this_cor <- cor.mat[[i]][[j]]$estimate
			this_cor.test <- cor.mat[[i]][[j]]
			this_col <- ifelse(this_cor.test$p.value<level,"red"
					,"blue")
			this_size <- (this_cor)^2
			cor_text <- ifelse(
					this_cor>0
					,substr(format(c(this_cor,.123456789),digits=2)[1],2,4)
					,paste('-',substr(format(c(this_cor,.123456789),digits=2)[1],3,5),sep='')
			)
			b<-as.data.frame(cor_text)
			b<-cbind(b,x_mid,y_mid,this_col,this_size,names(data)[j],names(data)[i])
			z_cor<-rbind(z_cor,b)
			j<-j+1
		}
	}
	names(z_cor)<-c('cor','x_mid','y_mid','p','rsq','x_label','y_label')
	z_cor$x_label <- ezLev(factor(z_cor$x_label),names(data))
	z_cor$y_label <- ezLev(factor(z_cor$y_label),names(data))
	diag <- z_cor[z_cor$x_label==z_cor$y_label,]
	z_cor<-z_cor[z_cor$x_label!=z_cor$y_label,]
	
	#start creating layers	
	points_layer <- geom_point(aes(x = x_var, y = y_var, alpha=trans),data = z)
	bin_layer<-geom_hex(data = z, mapping = aes(x = x_var, y = y_var,alpha=trans),bins=10)
	lm_line_layer <- stat_smooth(aes(x=x_var, y=y_var), method=line.method)
	cor_text <- geom_text(aes(x=y_mid, y=x_mid, label=cor, size = rsq, colour = p), data=z_cor)
	var_text <- geom_text(aes(x=y_mid, y=x_mid, label=x_label), data=diag, size=var_text_size)

	f <- facet_grid(y_label~x_label,scales='free')
	o <- theme(
			panel.grid.minor = element_blank()
			,panel.grid.major = element_blank()
			,axis.ticks = element_blank()
			,axis.text.y = element_blank()
			,axis.text.x = element_blank()
			,axis.title.y = element_blank()
			,axis.title.x = element_blank()
			,legend.position='none'
	)
	
	size_scale <- scale_size(limits = c(0,1),range=cor_text_limits)
	the.plot<-ggplot(data=z)
	if(type=="bins")
		the.plot<-the.plot+bin_layer
	else if(type=="points")
		the.plot<-the.plot+points_layer + scale_alpha_identity()
	the.plot<-the.plot+var_text+
			cor_text+
			f+
			o+
			size_scale
	if(type=="bins")
		the.plot<-the.plot+scale_fill_gradient(low="grey", high="black")
	if(lines)
		the.plot<-the.plot+lm_line_layer
	if(main=="auto")
		main<-cor.mat[[1]][[1]]$method
	the.plot<-the.plot+ggtitle(main)
	return(the.plot)
}

onesample.plot<-function(variables,data=NULL,test.value,scale=FALSE,type="hist",alpha=.2){
	Value <- ..density.. <- NULL
	vars<-eval(substitute(variables),data, parent.frame())
	if(length(dim(vars))<1.5)
		vars<-d(vars)
	data <- vars
	n<-nrow(data)
	var.ind <- 1:ncol(data)
	dat<-data.frame(rep(NA,length(var.ind)*n),rep(NA,length(var.ind)*n))
	names(dat)<-c("Value","Variable")
	cnt<-1
	for(i in (1:length(var.ind))*n-(n)){
		dat[(1:n)+i,1]<-as.numeric(data[[var.ind[cnt]]])
		if(missing("test.value"))
			center <-mean(dat[(1:n)+i,1],na.rm=TRUE)
		else
			center <- test.value
		if(scale)
			dat[(1:n)+i,1]<-(dat[(1:n)+i,1]-center)/sd(dat[(1:n)+i,1],na.rm=TRUE)
		dat[(1:n)+i,2]<-names(data)[var.ind[cnt]]
		cnt<-cnt+1
	}
	dat<-na.omit(dat)
	max.diff<-max(-min(dat$Value),max(dat$Value))
	p<-ggplot(dat,aes(x=Value))
	
	hist<-geom_histogram(aes(x=Value,y=..density..))
	
	jit<-geom_jitter(aes(y=Value,x=0),alpha = alpha, colour = "#326432",  
			position = position_jitter(height = 0)) 
	box<-geom_boxplot(aes(y=Value,x=0),fill = NA, outlier.colour = "white", 
			outlier.size = 0, colour = "black", size = 0.75)
	o <- theme(axis.text.y = element_blank(), axis.title.y = element_blank())
	
	if(scale){
		p<-p+facet_grid(Variable~.)
		if(type=="hist" && !missing("test.value"))
			p <- p + hist + geom_vline(xintercept = 0,colour="red",size=1.5) +
					xlim(-max.diff,max.diff)
		else if(type=="box")
			p<-p+ jit+box+ylim(-max.diff,max.diff)+coord_flip()
		p<-p+ylab("Scaled Values")+o
	}else{
		if(ncol(vars)>1.5)
			p<-p+facet_wrap(~Variable,scales="free")+o
		else
			p<-p+ if(type=="hist") xlab(names(vars)[1]) else xlab("Value")

		if(type=="hist"){
			p<-p+hist
			if(!missing("test.value"))
				p<-p+ geom_vline(xintercept = test.value,colour="red",size=1.5)
		}else if(type=="box" && !missing("test.value"))
			p<-p+ geom_hline(yintercept = test.value,colour="red",size=1.5)+
					jit+box+o
		else if(type=="box")
			p<-p+jit+box+o + if(ncol(vars)<1.5) ylab(names(vars)[1]) else ylab("Value")
			
	}
	p
}

descriptive.table<-function(vars,strata,data,func.names = c("Mean","St. Deviation","Median",
								"25th Percentile","75th Percentile",
								"Minimum","Maximum","Skew","Kurtosis","Valid N"),func.additional){
	dat<-eval(substitute(vars),data, parent.frame())
	if(length(dim(dat))<1.5)
		dat<-d(dat)
	if(any(!sapply(dat,is.numeric))){
		dat<-dat[sapply(dat,is.numeric)]
		warning("Non-numeric variables dropped from descriptive table")
	}
	if(missing(strata)){
		strata<-rep("all cases",dim(dat)[1])
	}else{
		strata<-eval(substitute(strata),data, parent.frame())
		if(length(dim(strata))<1.5)
			strata<-d(strata)
	}
	
	if(!all(sapply(dat,is.numeric))) stop("Descriptives can only be run on numeric variables")
	func.indexes <- pmatch(func.names, c("Mean","St. Deviation","Median","25th Percentile",
							"75th Percentile","Minimum","Maximum","Skew",
							"Kurtosis","Valid N"))
	functions<-c(	function(x) mean(x,na.rm=TRUE),
					function(x) sd(x,na.rm=TRUE),
					function(x) median(x,na.rm=TRUE),
					function(x) quantile(x,.25,na.rm=TRUE),
					function(x) quantile(x,.75,na.rm=TRUE),
					function(x) min(x,na.rm=TRUE),
					function(x) max(x,na.rm=TRUE),
					function(x) skewness(x,na.rm=TRUE,type=2), 
					function(x) kurtosis(x,na.rm=TRUE,type=2), 
					function(x) sum(!is.na(x))
				)
	functions<-functions[func.indexes]

	if(!missing(func.additional)){
		if(!is.list(func.additional) || is.null(names(func.additional)))
			stop("func.additional must be a named list of functions")
		functions <- c(functions,unlist(func.additional))
		func.names<-c(func.names,names(func.additional))
	}

	##calculate statistics
	tbl.list<-list()
	for(ind in 1:length(functions)){
		tbl.list[[func.names[ind]]]<-by(dat, strata, 
									function(x) sapply(x, functions[[ind]]) ,simplify=FALSE)
	}
	##format into table
	result<-list()
	for(ind in 1:length(tbl.list[[1]])){
    		d <- dim(tbl.list[[1]])
    		dn <- dimnames(tbl.list[[1]])
    		dnn <- names(dn)
		ii <- ind - 1
		name<-""
		for (j in seq_along(dn)) {
			iii <- ii%%d[j] + 1
			ii <- ii%/%d[j]
			name <- paste(name,dnn[j], ": ", dn[[j]][iii], " ", sep = "")
		}		
		result[[name]]<-sapply(tbl.list,function(x) x[[ind]])
	}

	##clean out nulls
	result<-result[!sapply(result,function(x)all(sapply(x,function(x)all(is.null(x)))))]
	return(result)
}

oneway.plot<-function(formula,data=NULL,alpha=.2,
		box=TRUE,points=TRUE,scale=FALSE){
	Factor <- Value <- NULL
	n<-nrow(data)
	variables<-eval(formula[[2]],data,parent.frame())
	factor.var<-eval(formula[[3]],data,parent.frame())
	if(length(dim(variables))<1.5){
		variables<-d(variables)
		fn<-formula[[2]]
		names(variables)<-if(is.call(fn)) format(fn) else as.character(fn)
	}else
		variables<-as.data.frame(variables)
	if(length(dim(factor.var))>1.5)
		factor.var <- factor.var[,1]
	n.var<-ncol(variables)
	dat<-data.frame(rep(NA,n.var*n),rep(NA,n.var*n),
			rep(NA,n.var*n))
	names(dat)<-c("Value","Factor","Variable")
	cnt<-1
	for(i in (1:n.var)*n-(n)){
		dat[(1:n)+i,1]<-as.numeric(variables[[cnt]])
		if(scale)
			dat[(1:n)+i,1]<-(dat[(1:n)+i,1]-mean(dat[(1:n)+i,1],na.rm=TRUE))/
					sd(dat[(1:n)+i,1],na.rm=TRUE)
		dat[(1:n)+i,3]<-names(variables)[cnt]
		cnt<-cnt+1
	}
	dat[,2]<-rep(factor.var,n.var)
	dat[,2]<-as.factor(dat[,2])
	dat[,3]<-as.factor(dat[,3])
	dat<-na.omit(dat)
	p<-ggplot(dat, aes(Factor,Value))
	if(points){
		p<-p+geom_jitter(aes(colour=Factor),alpha = alpha,
				position=position_jitter(height=0))+theme(legend.position = "none")
		if(length(levels(dat$Factor))>2 & length(levels(dat$Factor))<9)
			p<-p+scale_colour_brewer(palette="Dark2") 
		if(box)
			p<-p+geom_boxplot(fill = NA, outlier.colour="white", outlier.size=0,
					colour="black",size=.75)
	}else
	if(box)
		p<-p+geom_boxplot(colour="black",size=.75)
	else
		stop("Either box or points must be TRUE") 
	if(!scale){
		if(n.var==1)
			p<-p+ ylab(dat[1,3]) 
		else 
			p<-p+facet_wrap(~Variable,scales="free_y")+ylab("")
	}else{
		if(n.var==1) 
			p<-p+ylab(paste("Scaled",dat[1,3])) 
		else 
			p<-p+facet_grid(Variable~.,scales="free_y")+ylab("Standardized Value")
	}
	fn<-formula[[3]]
	fact.name<-if(is.call(fn)) format(fn) else as.character(fn)
	p<-p+xlab(fact.name)#+coord_flip()
	p
}

perm.t.test<-function(x,y,statistic=c("t","mean"),
			alternative=c("two.sided", "less", "greater"), midp=TRUE, B=10000){
	DNAME <- paste(deparse(substitute(x)), "and", deparse(substitute(y)))
	x<-na.omit(x)
	y<-na.omit(y)
	nx<-length(x)
	ny<-length(y)
	alternative<-match.arg(alternative)
	statistic<-match.arg(statistic)
	mult<- if(midp) .5 else 1
	var1<-var#function(s){.Internal(cov(s, NULL, TRUE, FALSE))}
	sum1<-.Primitive("sum")
	dat<-c(x,y)	
	if(statistic=="mean"){
		METHOD<-paste("Two-Sample permutation test using mean difference (B=", B,")")
		stat<-sum(y)
		nmin<-ny
		samp<-replicate(B,sum(sample(dat,nmin)))
		STAT<-mean(x)-mean(y)
		names(STAT)<-"Mean Difference"
	}else{
		METHOD<-paste("Two-Sample permutation test using Welsh's t (B=",B,")")
		stat<-(mean(x)- mean(y))/sqrt(var1(x)/nx+var1(y)/ny)
		samp<-replicate(B,sample(dat,nx+ny))
		sx<-apply(samp[1:nx,],2,function(s) c(sum1(s),var1(s)))
		sy<-apply(samp[(nx+1):(nx+ny),],2,function(s) c(sum1(s),var1(s)))
		samp<-(sx[1,]/nx-sy[1,]/ny)/sqrt(sx[2,]/nx+sy[2,]/ny)
		STAT<-stat
		names(STAT)<-"Welsh t-statistic"
	}
	lower<-sum(samp<stat)/(B+1)
	upper<-sum(samp>stat)/(B+1)
	equal<-sum(samp==stat)/(B+1)
	if(alternative=="two.sided")
		p.value<-2*min(lower,upper)+2*mult*equal
	else if(alternative=="less")
		p.value<-lower+mult*equal
	else
		p.value<-upper+mult*equal
	p.value<-min(p.value,1)
	RVAL<-list(statistic=STAT,p.value=p.value,method=METHOD,data.name=DNAME,
				alternative=alternative,B=B)
	class(RVAL)<-"htest"
	return(RVAL)
}

menuFunctions<-(function(){
			menus<-list()
			
			getMenus<-function(){
				return(menus)
			}
			
			setMenus<-function(newMenus){
				menus<<-newMenus
			}
			
			addMenu<-function(name, pos=length(menus)+1){
				newMenu<-list(name=name,items = list() )
				position<-pos
				if(length(menus)==0)
					menus <<-list(newMenu)
				else if(pos==1)
					menus <<- c(list(newMenu),menus)
				else if(pos<=length(menus))
					menus <<- c(menus[1:(pos-1)],list(newMenu),menus[pos:length(menus)])
				else if(pos>length(menus))
					menus <<- c(menus,list(newMenu))
				names(menus)[pos] <<- name 
			}
			
			addMenuItem<-function(name, pos=NULL, command, menuName, silent=TRUE){
				m.ind<-which(sapply(menus,function(x) x$name==menuName))
				m<-menus[[m.ind]]$items
				if(is.null(pos)) pos <-length(m)+1
				newItem<-list(name=name,command=command,silent=silent)
				if(length(m)==0){
					menus[[m.ind]]$items<<-list(newItem)
					names(menus[[m.ind]]$items)<<-name
					return(NULL)
				}
				if(pos==1)
					m <- c(list(newItem),m)
				else if(pos<=length(m))
					m <- c(m[1:(pos-1)],list(newItem),m[pos:length(m)])
				else if(pos>length(m))
					m <- c(m,list(newItem))
				menus[[m.ind]]$items <<- m
				names(menus[[m.ind]]$items)[pos] <<- name 
			}
			return(list(deducer.getmenus=getMenus,
							deducer.setmenus=setMenus,
							deducer.addmenu=addMenu,
							deducer.addMenuItem=addMenuItem))
})()

deducer.getMenus <- menuFunctions[["deducer.getmenus"]]
deducer.setMenus <- menuFunctions[["deducer.setmenus"]]
deducer.addMenu <- menuFunctions[["deducer.addmenu"]]
deducer.addMenuItem <- menuFunctions[["deducer.addMenuItem"]]

##Runs Frequencies on a set of variables
frequencies<-function(data,r.digits=1){
	frequencies.var<-function(variable){
		freq<-table(variable)
		freq<-as.data.frame(freq)
		freq$Percentage<-round(freq$Freq/sum(freq$Freq)*100,r.digits)
		freq$Cum.Percentage<-round(cumsum(freq$Freq)/sum(freq$Freq)*100,r.digits)
		
		num.miss<-matrix(0,nrow=1,ncol=3)
		colnames(num.miss)<-c("Valid","Missing","Total")
		row.names(num.miss)<-"# of cases"
		num.miss[1,]<-c(sum(freq$Freq),sum(is.na(variable)),length(variable))
		
		colnames(freq)<-c("Value","# of Cases","      %","Cumulative %")
		result<-list(Frequencies=freq,case.summary=num.miss)
		class(result)<-"freq.table"
		return(result)
	}
	if(!is.data.frame(data)){
		data<-as.data.frame(data)
	}
	
	results<-list()
	
	for(index in 1:dim(data)[2]){
		results[[names(data)[index]]]<-frequencies.var(data[,index])        
	}
	return(results)
}

##Prints frequency tables
print.freq.table<-function(x,...){
	cat("------------------------------------------------------------\n")
	cat("--                        Frequencies                     --\n")
	cat("--                                                        --\n")
	
	print(x[[1]])
	cat("--                                                        --\n")
	cat("--                        Case Summary                    --\n")
	cat("--                                                        --\n")
	print(x[[2]])
	cat("--                                                        --\n")
	cat("--                                                        --\n")
	cat("------------------------------------------------------------\n\n\n\n\n\n")
} 

# TODO: Add comment
# 
# Author: ianfellows
###############################################################################



########################################################################
#
#				iplots: Scatter
#
########################################################################

.makeIplotDialog <- function(){
	RFunction <- J("org.rosuda.deducer.widgets.param.RFunction")
	RFunctionDialog <- J("org.rosuda.deducer.widgets.param.RFunctionDialog")
	ParamVariable <- J("org.rosuda.deducer.widgets.param.ParamVariable")
	ParamCharacter<- J("org.rosuda.deducer.widgets.param.ParamCharacter")
	
	rf <- new(RFunction,"Interactive Scatter Plot")
	rf$setName("iplot")
	rf$setRequiresVariableSelector(TRUE)
	
	var1 <- new(ParamVariable,"x")
	rf$add(var1)
	
	var2 <- new(ParamVariable,"y")
	rf$add(var2)	
	
	pcx <- new(ParamCharacter,"xlab")
	pcx$setTitle("x label")
	rf$add(pcx)
	
	pcy <- new(ParamCharacter,"ylab")
	pcy$setTitle("y label")
	rf$add(pcy)	
	
	rfd <- new(RFunctionDialog, rf)
	rfd$setLocationRelativeTo(.jnull())
	rfd$setSize(460L,350L)
	rfd
}

########################################################################
#
#				iplots: Histogram
#
########################################################################

.makeIhistDialog <- function(){
	RFunction <- J("org.rosuda.deducer.widgets.param.RFunction")
	RFunctionDialog <- J("org.rosuda.deducer.widgets.param.RFunctionDialog")
	ParamVariable <- J("org.rosuda.deducer.widgets.param.ParamVariable")
	ParamNumeric<- J("org.rosuda.deducer.widgets.param.ParamNumeric")
	
	rf <- new(RFunction)
	rf$setName("ihist")
	rf$setTitle("Interactive Histogram")
	rf$setRequiresVariableSelector(TRUE)
	
	var1 <- new(ParamVariable,"var")
	rf$add(var1)
	
	
	pcx <- new(ParamNumeric,"binw")
	pcx$setTitle("Bin Width")
	pcx$setRequired(FALSE)
	pcx$setLowerBound(0)
	rf$add(pcx)
	
	rfd <- new(RFunctionDialog, rf)
	rfd$setLocationRelativeTo(.jnull())
	rfd$setSize(460L,300L)
	rfd
}

########################################################################
#
#				iplots: Bar
#
########################################################################

.makeIbarDialog <- function(){
	RFunction <- J("org.rosuda.deducer.widgets.param.RFunction")
	RFunctionDialog <- J("org.rosuda.deducer.widgets.param.RFunctionDialog")
	ParamVariable <- J("org.rosuda.deducer.widgets.param.ParamVariable")
	ParamLogical<- J("org.rosuda.deducer.widgets.param.ParamLogical")
	
	rf <- new(RFunction)
	rf$setName("ibar")
	rf$setTitle("Interactive Bar Chart")
	rf$setRequiresVariableSelector(TRUE)
	
	var1 <- new(ParamVariable,"var")
	rf$add(var1)
	
	
	pcx <- new(ParamLogical,"isSpine")
	pcx$setTitle("Spine Plot")
	rf$add(pcx)
	
	rfd <- new(RFunctionDialog, rf)
	rfd$setLocationRelativeTo(.jnull())
	rfd$setSize(460L,300L)
	rfd
}



########################################################################
#
#				iplots: Mosaic
#
########################################################################

.makeImosaicDialog <- function(){
	RFunction <- J("org.rosuda.deducer.widgets.param.RFunction")
	RFunctionDialog <- J("org.rosuda.deducer.widgets.param.RFunctionDialog")
	ParamMultipleVariables <- J("org.rosuda.deducer.widgets.param.ParamMultipleVariables")
	ParamCharacter<- J("org.rosuda.deducer.widgets.param.ParamCharacter")
	
	rf <- new(RFunction)
	rf$setName("imosaic")
	rf$setTitle("Interactive Mosaic Chart")
	rf$setRequiresVariableSelector(TRUE)
	
	var1 <- new(ParamMultipleVariables,"vars")
	rf$add(var1)
	
	
	pcx <- new(ParamCharacter,"type")
	pcx$setTitle("Type")
	pcx$setOptions(c("observed", "expected", "fluctuation","same.bin.size",
					"multiple.barchart"))
	pcx$setViewType(pcx$VIEW_COMBO)
	rf$add(pcx)
	
	rfd <- new(RFunctionDialog, rf)
	rfd$setLocationRelativeTo(.jnull())
	rfd$setSize(460L,400L)
	rfd
}


########################################################################
#
#				iplots: Box long
#
########################################################################

.makeIboxLongDialog <- function(){
	RFunction <- J("org.rosuda.deducer.widgets.param.RFunction")
	RFunctionDialog <- J("org.rosuda.deducer.widgets.param.RFunctionDialog")
	ParamVariable <- J("org.rosuda.deducer.widgets.param.ParamVariable")
	
	
	rf <- new(RFunction)
	rf$setName("ibox")
	rf$setTitle("Interactive Box Plot")
	rf$setRequiresVariableSelector(TRUE)
	
	var1 <- new(ParamVariable,"y")
	var1$setName(.jnull())
	rf$add(var1)
	
	var2 <- new(ParamVariable,"x")
	var2$setName(.jnull())
	rf$add(var2)	
	
	
	rfd <- new(RFunctionDialog, rf)
	rfd$setLocationRelativeTo(.jnull())
	rfd$setSize(460L,300L)
	rfd
}

########################################################################
#
#				iplots: Box wide
#
########################################################################

.makeIboxWideDialog <- function(){
	RFunction <- J("org.rosuda.deducer.widgets.param.RFunction")
	RFunctionDialog <- J("org.rosuda.deducer.widgets.param.RFunctionDialog")
	ParamMultipleVariables <- J("org.rosuda.deducer.widgets.param.ParamMultipleVariables")
	ParamCharacter<- J("org.rosuda.deducer.widgets.param.ParamCharacter")
	
	rf <- new(RFunction)
	rf$setName("ibox")
	rf$setTitle("Interactive Box Plot")
	rf$setRequiresVariableSelector(TRUE)
	
	var1 <- new(ParamMultipleVariables,"Variables")
	var1$setName(.jnull())
	rf$add(var1)
	
	rfd <- new(RFunctionDialog, rf)
	rfd$setLocationRelativeTo(.jnull())
	rfd$setSize(460L,400L)
	rfd
}




########################################################################
#
#				iplots: Par coord plot
#
########################################################################

.makeIpcpDialog <- function(){
	RFunction <- J("org.rosuda.deducer.widgets.param.RFunction")
	RFunctionDialog <- J("org.rosuda.deducer.widgets.param.RFunctionDialog")
	ParamMultipleVariables <- J("org.rosuda.deducer.widgets.param.ParamMultipleVariables")
	ParamCharacter<- J("org.rosuda.deducer.widgets.param.ParamCharacter")
	
	rf <- new(RFunction)
	rf$setName("ipcp")
	rf$setTitle("Interactive Parallel Coordinate Plot")
	rf$setRequiresVariableSelector(TRUE)
	
	var1 <- new(ParamMultipleVariables,"Variables")
	var1$setName(.jnull())
	rf$add(var1)
	
	rfd <- new(RFunctionDialog, rf)
	rfd$setLocationRelativeTo(.jnull())
	rfd$setSize(460L,400L)
	rfd
}

## TODO: Add comment
## 
## Author: Ian
################################################################################


#ggExtras is no longer compatible with ggplot2 0.9


#
#
#ggExtraGuiElements <-  function(){
#	
#	eval(parse(text="require('ggExtra')"))
#	cat("\nnote: the ggExtra GUI interface is experimental\n")
#	
#	
#	PlottingElement <- J("org.rosuda.deducer.plots.PlottingElement");
#	PlotController <- J("org.rosuda.deducer.plots.PlotController");
#	Theme <- J("org.rosuda.deducer.plots.Theme")
#	Layer <- J("org.rosuda.deducer.plots.Layer")
#	Geom <- J("org.rosuda.deducer.plots.Geom")
#	Stat <- J("org.rosuda.deducer.plots.Stat")
#	Scale <- J("org.rosuda.deducer.plots.Scale")
#	Position <- J("org.rosuda.deducer.plots.Position")
#	Aes <- J("org.rosuda.deducer.plots.Aes")
#	
#	Param <- J("org.rosuda.deducer.widgets.param.Param")
#	ParamNumeric <- J("org.rosuda.deducer.widgets.param.ParamNumeric")
#	ParamCharacter <- J("org.rosuda.deducer.widgets.param.ParamCharacter")
#	
#	Color <- J("java.awt.Color")
#	
#	#initialize plot elements
#	PlotController$init()
#	
#	#######################################	#######################################
#										#themes
#	#######################################	#######################################
#	
#	#a paramerter controlling base text size
#	pn <- new(ParamNumeric,"base_size")
#	pn$setViewType(Param$VIEW_ENTER)
#	pn$setLowerBound(0)
#	pn$setValue(14)
#	pn$setValue(14)
#	pn$setDefaultValue(14)	
#	
#	#add theme bb
#	pe <- PlottingElement$createElement("theme","bb");
#	theme <- new(Theme)
#	theme$setName("theme_bb")
#	theme$params$add(pn$clone())
#	pe$setModel(theme)
#	PlotController$addTheme(pe)
#	
#	#add theme bw2
#	pe <- PlottingElement$createElement("theme","bw2");
#	theme <- new(Theme)
#	theme$setName("theme_bw2")
#	theme$params$add(pn$clone())
#	pe$setModel(theme)
#	PlotController$addTheme(pe)
#	
#	#add theme dark
#	pe <- PlottingElement$createElement("theme","dark");
#	theme <- new(Theme)
#	theme$setName("theme_dark")
#	theme$params$add(pn$clone())
#	pe$setModel(theme)
#	PlotController$addTheme(pe)
#	
#	#add theme flashy
#	pe <- PlottingElement$createElement("theme","flashy");
#	theme <- new(Theme)
#	theme$setName("theme_flashy")
#	theme$params$add(pn$clone())
#	pe$setModel(theme)
#	PlotController$addTheme(pe)
#	
#	#add theme gray2
#	pe <- PlottingElement$createElement("theme","gray2");
#	theme <- new(Theme)
#	theme$setName("theme_gray2")
#	theme$params$add(pn$clone())
#	pe$setModel(theme)
#	PlotController$addTheme(pe)
#	
#	#add theme minimal
#	pe <- PlottingElement$createElement("theme","minimal");
#	theme <- new(Theme)
#	theme$setName("theme_minimal")
#	theme$params$add(pn$clone())
#	pe$setModel(theme)
#	PlotController$addTheme(pe)
#	
#	#add theme talk
#	pe <- PlottingElement$createElement("theme","talk");
#	theme <- new(Theme)
#	theme$setName("theme_talk")
#	theme$params$add(pn$clone())
#	pe$setModel(theme)
#	PlotController$addTheme(pe)
#	
#	
#	#######################################	#######################################
#										#geoms
#	#######################################	#######################################
#	
#	
#	
#	#######################################
#	#add geom_ellipse
#	#######################################
#	geom <- new(Geom)
#	geom$name <- "ellipse"
#	geom$defaultStat <- "identity"
#	geom$defaultPosition <- "identity"
#	
#	aes <- Aes$makeAes("x")
#	aes$required <- TRUE
#	geom$aess$add(aes)
#	
#	aes <- Aes$makeAes("y")
#	aes$required <- TRUE
#	geom$aess$add(aes)
#	
#	aes <- Aes$makeAes("size")
#	geom$aess$add(aes)
#	
#	aes <- Aes$makeAes("angle")
#	geom$aess$add(aes)
#	
#	aes <- Aes$makeAes("ar")
#	aes$dataType <- Aes$DATA_NUMERIC
#	geom$aess$add(aes)
#	
#	aes <- Aes$makeAes("colour")
#	aes$value <- .jcast(Color$black)
#	aes$defaultValue <- .jcast(Color$black)
#	geom$aess$add(aes)
#	
#	aes <- Aes$makeAes("fill")
#	aes$value <- .jcast(Color$black)
#	aes$defaultValue <- .jcast(Color$black)
#	geom$aess$add(aes)
#	
#	aes <- Aes$makeAes("alpha")
#	geom$aess$add(aes)
#	
#	geomLayer <- new(Layer)
#	geomLayer$isGeom = TRUE
#	geomLayer$name <- "geom_ellipse"
#	geomLayer$geom <- geom
#	geomLayer$stat <- Stat$makeIdentity()
#	geomLayer$pos <- Position$makePosition("identity")
#	
#	pe <- PlottingElement$createElement("geom","ellipse");
#	pe$setModel(geomLayer)
#	PlotController$addGeom(pe)
#	
#	#######################################
#	#add geom_field
#	#######################################
#	geom <- new(Geom)
#	geom$name <- "field"
#	geom$defaultStat <- "identity"
#	geom$defaultPosition <- "identity"
#	
#	aes <- Aes$makeAes("x")
#	aes$required <- TRUE
#	geom$aess$add(aes)
#	
#	aes <- Aes$makeAes("y")
#	aes$required <- TRUE
#	geom$aess$add(aes)
#	
#	aes <- Aes$makeAes("angle")
#	aes$required <- TRUE
#	aes$defaultUseVariable <- TRUE
#	geom$aess$add(aes)
#	
#	aes <- Aes$makeAes("length")
#	aes$required <- TRUE
#	aes$defaultUseVariable <- TRUE
#	aes$dataType <- Aes$DATA_NUMERIC
#	geom$aess$add(aes)
#	
#	aes <- Aes$makeAes("size")
#	geom$aess$add(aes)
#	
#	aes <- Aes$makeAes("colour")
#	aes$value <- .jcast(Color$black)
#	aes$defaultValue <- .jcast(Color$black)
#	geom$aess$add(aes)
#	
#	aes <- Aes$makeAes("linetype")
#	geom$aess$add(aes)
#	
#	geomLayer <- new(Layer)
#	geomLayer$isGeom = TRUE
#	geomLayer$name <- "geom_field"
#	geomLayer$geom <- geom
#	geomLayer$stat <- Stat$makeIdentity()
#	geomLayer$pos <- Position$makePosition("identity")
#	
#	pe <- PlottingElement$createElement("geom","field");
#	pe$setModel(geomLayer)
#	PlotController$addGeom(pe)
#
#	#######################################
#	#add geom_fielduv
#	#######################################
#	geom <- new(Geom)
#	geom$name <- "fielduv"
#	geom$defaultStat <- "identity"
#	geom$defaultPosition <- "identity"
#	
#	aes <- Aes$makeAes("x")
#	aes$required <- TRUE
#	geom$aess$add(aes)
#	
#	aes <- Aes$makeAes("y")
#	aes$required <- TRUE
#	geom$aess$add(aes)
#	
#	aes <- Aes$makeAes("abscissa")
#	aes$required <- TRUE
#	aes$defaultUseVariable <- TRUE
#	aes$dataType <- Aes$DATA_NUMERIC
#	geom$aess$add(aes)
#	
#	aes <- Aes$makeAes("ordinate")
#	aes$required <- TRUE
#	aes$defaultUseVariable <- TRUE
#	aes$dataType <- Aes$DATA_NUMERIC
#	geom$aess$add(aes)
#	
#	aes <- Aes$makeAes("colour")
#	aes$value <- .jcast(Color$black)
#	aes$defaultValue <- .jcast(Color$black)
#	geom$aess$add(aes)
#	
#	aes <- Aes$makeAes("size")
#	aes$value <- .jcast(new(J("java.lang.Double"),1))
#	aes$defaultValue <- .jcast(new(J("java.lang.Double"),1))
#	geom$aess$add(aes)
#	
#	aes <- Aes$makeAes("linetype")
#	geom$aess$add(aes)
#	
#	geomLayer <- new(Layer)
#	geomLayer$isGeom = TRUE
#	geomLayer$name <- "geom_fielduv"
#	geomLayer$geom <- geom
#	geomLayer$stat <- Stat$makeIdentity()
#	geomLayer$pos <- Position$makePosition("identity")
#	
#	pe <- PlottingElement$createElement("geom","fielduv");
#	pe$setModel(geomLayer)
#	PlotController$addGeom(pe)
#	
#	#######################################
#	#add geom_ngon
#	#######################################
#	geom <- new(Geom)
#	geom$name <- "ngon"
#	geom$defaultStat <- "identity"
#	geom$defaultPosition <- "identity"
#	
#	aes <- Aes$makeAes("x")
#	aes$required <- TRUE
#	geom$aess$add(aes)
#	
#	aes <- Aes$makeAes("y")
#	aes$required <- TRUE
#	geom$aess$add(aes)
#	
#	aes <- Aes$makeAes("sides")
#	aes$required <- FALSE
#	aes$dataType <- Aes$DATA_NUMERIC
#	aes$value <- .jcast(new(J("java.lang.Double"),5))
#	aes$defaultValue <- .jcast(new(J("java.lang.Double"),5))
#	geom$aess$add(aes)
#	
#	aes <- Aes$makeAes("size")
#	aes$value <- .jcast(new(J("java.lang.Double"),1))
#	aes$defaultValue <- .jcast(new(J("java.lang.Double"),1))
#	geom$aess$add(aes)
#		
#	
#	aes <- Aes$makeAes("angle")
#	geom$aess$add(aes)
#	
#	aes <- Aes$makeAes("ar")
#	aes$required <- FALSE
#	aes$dataType <- Aes$DATA_NUMERIC
#	aes$value <- .jcast(new(J("java.lang.Double"),1))
#	aes$defaultValue <- .jcast(new(J("java.lang.Double"),1))	
#	geom$aess$add(aes)
#	
#	aes <- Aes$makeAes("colour")
#	aes$value <- .jcast(Color$gray)
#	aes$defaultValue <- .jcast(Color$gray)
#	geom$aess$add(aes)
#	
#	aes <- Aes$makeAes("fill")
#	geom$aess$add(aes)
#	
#	aes <- Aes$makeAes("alpha")
#	geom$aess$add(aes)	
#	
#	aes <- Aes$makeAes("lex")
#	aes$required <- FALSE
#	aes$dataType <- Aes$DATA_NUMERIC
#	aes$value <- .jcast(new(J("java.lang.Double"),1))
#	aes$defaultValue <- .jcast(new(J("java.lang.Double"),1))	
#	geom$aess$add(aes)
#	
#	geomLayer <- new(Layer)
#	geomLayer$isGeom = TRUE
#	geomLayer$name <- "geom_ngon"
#	geomLayer$geom <- geom
#	geomLayer$stat <- Stat$makeIdentity()
#	geomLayer$pos <- Position$makePosition("identity")
#	
#	pe <- PlottingElement$createElement("geom","ngon");
#	pe$setModel(geomLayer)
#	PlotController$addGeom(pe)
#	
#	#######################################
#	#add geom_point2
#	#######################################
#	geom <- new(Geom)
#	geom$name <- "point2"
#	geom$defaultStat <- "identity"
#	geom$defaultPosition <- "identity"
#	
#	aes <- Aes$makeAes("x")
#	aes$required <- TRUE
#	geom$aess$add(aes)
#	
#	aes <- Aes$makeAes("y")
#	aes$required <- TRUE
#	geom$aess$add(aes)
#	
#	aes <- Aes$makeAes("shape")
#	geom$aess$add(aes)
#	
#	aes <- Aes$makeAes("size")
#	aes$value <- .jcast(new(J("java.lang.Double"),2))
#	aes$defaultValue <- .jcast(new(J("java.lang.Double"),2))
#	geom$aess$add(aes)
#	
#	aes <- Aes$makeAes("colour")
#	aes$value <- .jcast(Color$black)
#	aes$defaultValue <- .jcast(Color$black)
#	geom$aess$add(aes)
#	
#	aes <- Aes$makeAes("fill")
#	geom$aess$add(aes)
#	
#	aes <- Aes$makeAes("alpha")
#	geom$aess$add(aes)	
#	
#	aes <- Aes$makeAes("lex")
#	aes$required <- FALSE
#	aes$dataType <- Aes$DATA_NUMERIC
#	aes$value <- .jcast(new(J("java.lang.Double"),1))
#	aes$defaultValue <- .jcast(new(J("java.lang.Double"),1))	
#	geom$aess$add(aes)
#	
#	pc <- new(ParamCharacter,"size.unit")
#	pc$setOptions(c("native","cm","mm"))
#	pc$setViewType(Param$VIEW_EDITABLE_COMBO)
#	geom$params$add(pc)
#	
#	geomLayer <- new(Layer)
#	geomLayer$isGeom = TRUE
#	geomLayer$name <- "geom_point2"
#	geomLayer$geom <- geom
#	geomLayer$stat <- Stat$makeIdentity()
#	geomLayer$pos <- Position$makePosition("identity")
#	
#	pe <- PlottingElement$createElement("geom","point2");
#	pe$setModel(geomLayer)
#	PlotController$addGeom(pe)
#	
#	
#	#######################################
#	#add geom_star
#	#######################################
#	geom <- new(Geom)
#	geom$name <- "star"
#	geom$defaultStat <- "identity"
#	geom$defaultPosition <- "identity"
#	
#	aes <- Aes$makeAes("x")
#	aes$required <- TRUE
#	geom$aess$add(aes)
#	
#	aes <- Aes$makeAes("y")
#	aes$required <- TRUE
#	geom$aess$add(aes)
#	
#	aes <- Aes$makeAes("sides")
#	aes$required <- FALSE
#	aes$dataType <- Aes$DATA_NUMERIC
#	aes$value <- .jcast(new(J("java.lang.Double"),5))
#	aes$defaultValue <- .jcast(new(J("java.lang.Double"),5))
#	geom$aess$add(aes)
#	
#	aes <- Aes$makeAes("size")
#	aes$value <- .jcast(new(J("java.lang.Double"),1))
#	aes$defaultValue <- .jcast(new(J("java.lang.Double"),1))
#	geom$aess$add(aes)
#	
#	aes <- Aes$makeAes("angle")
#	geom$aess$add(aes)
#	
#	aes <- Aes$makeAes("colour")
#	aes$value <- .jcast(Color$black)
#	aes$defaultValue <- .jcast(Color$black)
#	geom$aess$add(aes)
#	
#	aes <- Aes$makeAes("alpha")
#	geom$aess$add(aes)	
#	
#	geomLayer <- new(Layer)
#	geomLayer$isGeom = TRUE
#	geomLayer$name <- "geom_star"
#	geomLayer$geom <- geom
#	geomLayer$stat <- Stat$makeIdentity()
#	geomLayer$pos <- Position$makePosition("identity")
#	
#	pe <- PlottingElement$createElement("geom","star");
#	pe$setModel(geomLayer)
#	PlotController$addGeom(pe)
#	
#	#######################################	#######################################
#										#scales
#	#######################################	#######################################
#	
#	#scale_length
#	scale <- Scale$makeContinuous("length")
#	scale$setName("scale_length")
#	pe <- PlottingElement$createElement("scale","length");
#	pe$setModel(scale)
#	PlotController$addScale(pe)
#	
#	#scale_angle
#	scale <- Scale$makeContinuous("angle")
#	scale$setName("scale_angle")
#	pe <- PlottingElement$createElement("scale","angle");
#	pe$setModel(scale)
#	PlotController$addScale(pe)
#	
#	#scale_ar
#	scale <- Scale$makeContinuous("ar")
#	scale$setName("scale_ar")
#	pe <- PlottingElement$createElement("scale","ar");
#	pe$setModel(scale)
#	PlotController$addScale(pe)
#	
#	#scale_ar
#	scale <- Scale$makeDiscrete("ar")
#	pe <- PlottingElement$createElement("scale","ar");
#	pe$setModel(scale)
#	PlotController$addScale(pe)
#	
#	#scale_lex
#	scale <- Scale$makeContinuous("lex")
#	scale$setName("scale_lex")
#	pe <- PlottingElement$createElement("scale","lex");
#	pe$setModel(scale)
#	PlotController$addScale(pe)
#	
#	#scale_lex
#	scale <- Scale$makeDiscrete("lex")
#	pe <- PlottingElement$createElement("scale","lex");
#	pe$setModel(scale)
#	PlotController$addScale(pe)
#	
#	#scale_sides
#	scale <- Scale$makeContinuous("sides")
#	pe <- PlottingElement$createElement("scale","sides");
#	pe$setModel(scale)
#	PlotController$addScale(pe)
#	
#	#scale_sides
#	scale <- Scale$makeDiscrete("sides")
#	scale$setName("scale_sides")
#	pe <- PlottingElement$createElement("scale","sides");
#	pe$setModel(scale)
#	PlotController$addScale(pe)
#	
#	
#}
#
#
#
#
#

two.sample.test<-function(formula,data=NULL,test=t.test,...){

	variables<-eval(formula[[2]],data,parent.frame())
	factor.var<-eval(formula[[3]],data,parent.frame())
	if(length(dim(variables))<1.5){
		variables<-d(variables)
		fn<-formula[[2]]
		names(variables)<-if(is.call(fn)) format(fn) else as.character(fn)
	}
	if(length(dim(factor.var))>1.5)
		factor.var <- factor.var[,1]
	
	x<-as.factor(factor.var)
	y<-variables
	if(length(levels(as.factor(as.integer(x))))!=2L) stop("factor must have 2 and only two levels") 
	tests<-list()
	tests[[1]]<-list(func=deparse(substitute(test)),level=levels(x))
	sample1<-!is.na(x) & x==levels(x)[1]
	sample2<-!is.na(x) & x==levels(x)[2]
	for(var.name in colnames(y)){
		tmp.x<-na.omit(y[sample1,var.name,drop=TRUE])
		tmp.y<-na.omit(y[sample2,var.name,drop=TRUE])
		if(length(tmp.y)<3L || length(tmp.x)<3L){
			warning(paste(var.name,"must have at least 3 observations per group. Dropping..."))
			next
		}
		tests[[var.name]]<-test(tmp.x,tmp.y,...)

	}
	result<-multi.test(tests)
	if(identical(t.test,test))
		colnames(result)[1:2]<-c(paste("mean of",tests[[1]]$level[1]),paste("mean of",tests[[1]]$level[2]))	
	result	
}

multi.test<-function(tests){
	combine.strings<-function(strings){
		if(length(strings)==1)
			return(as.character(strings))
		tmp.str<-"("
		for(i in 1:length(strings))
			tmp.str<-paste(tmp.str,strings[i],if(i<length(strings)) "," else "",sep="")
		tmp.str<-paste(tmp.str,")",sep="")
		tmp.str
	}
	n<-length(tests)
	result<-as.data.frame(matrix(NA,ncol=8,nrow=n-1))
	rownames(result)<-names(tests)[-1]
	colnames(result)<-c("estimate 1","estimate 2",
						"Difference",paste(attr(tests[[2]]$conf.int,"conf.level")*100,
											"% CI Lower",sep=""),
						paste(attr(tests[[2]]$conf.int,"conf.level")*100,
											"% CI Upper",sep=""),
						names(tests[[2]]$statistic),paste(combine.strings(names(tests[[2]]$parameter)),"",sep=""),"p-value")
	for(i in 2:n){
		if(!is.null(tests[[i]]$est)){
			if(length(tests[[i]]$est)==2){
				result[i-1,1]<-tests[[i]]$est[1]
				result[i-1,2]<-tests[[i]]$est[2]
				result[i-1,3]<-tests[[i]]$est[1]-tests[[i]]$est[2]
			}else{
				if(i==2) colnames(result)[1]<-names(tests[[i]]$est)
				result[i-1,1]<-tests[[i]]$est[1]
			}
		}
		if(!is.null(tests[[i]]$conf.int)){
			result[i-1,4]<-tests[[i]]$conf.int[1]
			result[i-1,5]<-tests[[i]]$conf.int[2]
		}
		result[i-1,6]<-tests[[i]]$statistic
		if(!is.null(tests[[i]]$parameter)){
			if(length(tests[[i]]$parameter)==1)
				result[i-1,7]<-tests[[i]]$parameter
			else{
				result[i-1,7]<-combine.strings(tests[[i]]$parameter)
			}
		}
		result[i-1,8]<-tests[[i]]$p.value
	}
	empty.cols<-apply(result,2,function(x)all(is.na(x)))
	result<-as.data.frame(result[,!empty.cols])
	attr(result,"method")<-tests[[2]]$method
	attr(result,"alternative")<-tests[[2]]$alternative
	if(!is.null(tests[[2]]$null.value)){
		attr(result,"null.value")<-tests[[2]]$null.value
	}
	class(result)<-c("multi.test","data.frame")
	result
}

print.multi.test<-function(x,...){
	cat(format(attr(x,"method"),width=getOption("width"),justify="centre"),"\n")
	class(x)<-"data.frame"
	print(x,...)
	if(is.character(attr(x,"alternative")))
		cat("  HA:",attr(x,"alternative"),"\n")
	if(!is.null(attr(x,"null.value")))
		cat("  H0: ",names(attr(x,"null.value"))[1],"=",attr(x,"null.value"),"\n")
}

k.sample.test<-function(formula,data=NULL,test=oneway.test,...){
	variables<-eval(formula[[2]],data,parent.frame())
	factor.var<-eval(formula[[3]],data,parent.frame())
	if(length(dim(variables))<1.5){
		variables<-d(variables)
		fn<-formula[[2]]
		names(variables)<-if(is.call(fn)) format(fn) else as.character(fn)
	}
	if(length(dim(factor.var))>1.5)
		factor.var <- factor.var[,1]
	

	x <- factor(factor.var)
	y <- variables
	tests <- list()
	tests[[1]] <- list(func = deparse(substitute(test)), level = levels(x))
	for (var.name in colnames(y)) {
		tmp<-na.omit(data.frame(y=y[,var.name],x=x))
		tests[[var.name]] <- test(y~x,tmp, ...)
		tests[[var.name]]$parameter = round(tests[[var.name]]$parameter,3)
	}
	result <- multi.test(tests)
	result
}

# 
# Author: Ian
###############################################################################

summarylm<-function(object,correlation=FALSE,symbolic.cor = FALSE,white.adjust=FALSE,...){
	if(is.logical(white.adjust) && !white.adjust)
		return(stats::summary.lm(object,correlation,symbolic.cor,...))
	if(is.logical(white.adjust))
		white.adjust='hc3'
	ans<-list()
	ans$Estimate<-coef(object)
	ans[['Std..Error']]<-sqrt(diag(hccm(object,type=white.adjust)))
	ans[['t.value']]<-ans$Estimate/ans[['Std..Error']]
	ans[['p-value']]<-2*pt(abs(ans[['t.value']]),object$df.residual,lower.tail=FALSE)
	ans<-as.data.frame(ans)
	result<-list('Summary Table'=ans)
	if(correlation){
		result[['correlation']]<-hccm(object,type=white.adjust)/outer(ans[['Std..Error']],ans[['Std..Error']])
	}
	result
}

# TODO: Add comment
# 
# Author: Ian
###############################################################################





addComponent <- function(container, component, top, right, bottom, left, topType = "REL", 
		rightType = "REL", bottomType = "REL", leftType = "REL"){
	AnchorConstraint <- J("org.rosuda.JGR.layout.AnchorConstraint")
	top <- as.integer(top)
	right <- as.integer(right)
	bottom <- as.integer(bottom)
	left <- as.integer(left)
	d <- getSize(container)
	ht <- d[2]
	wd <- d[1]
	if(topType=="ABS")
		top <- as.integer(round(ht*top/1000))
	if(rightType=="ABS")
		right <- as.integer(round(wd-wd*right/1000))
	if(bottomType=="ABS")
		bottom <- as.integer(round(ht-ht*bottom/1000))
	if(leftType=="ABS")
		left <- as.integer(round(wd*left/1000))
	
	topType <-	if(topType=="REL") AnchorConstraint$ANCHOR_REL else if(topType=="ABS") AnchorConstraint$ANCHOR_ABS else AnchorConstraint$ANCHOR_NONE
	rightType <-	if(rightType=="REL") AnchorConstraint$ANCHOR_REL else if(rightType=="ABS") AnchorConstraint$ANCHOR_ABS else AnchorConstraint$ANCHOR_NONE
	bottomType <-	if(bottomType=="REL") AnchorConstraint$ANCHOR_REL else if(bottomType=="ABS") AnchorConstraint$ANCHOR_ABS else AnchorConstraint$ANCHOR_NONE
	leftType <-	if(leftType=="REL") AnchorConstraint$ANCHOR_REL else if(leftType=="ABS") AnchorConstraint$ANCHOR_ABS else AnchorConstraint$ANCHOR_NONE
	container$add(component,new(AnchorConstraint,top,right,bottom,left,
					topType,rightType,bottomType,leftType))
	
	#container$add(component,top, right, bottom, left, topType, rightType, bottomType, leftType)
	
}

getSize <- function(component){
	dim <- component$getSize()
	c(dim$getWidth(),dim$getHeight())
}

setSize <- function(component,width,height){
	component$setSize(as.integer(width),as.integer(height))
	component$setPreferredSize(new(J("java.awt.Dimension"),as.integer(width),as.integer(height)))
}

execute <-function(cmd){
	if(!.jgr)
		DeducerMain$execute(cmd)
	else
		DeducerMain$executeAndContinue(cmd)
}

plot.cor.matrix<-function(x,y=NULL,size=10,...){
	x.o <- y.o <- NULL
	x<-as.matrix(x)
	n.r<-nrow(x)
	n.c<-ncol(x)
	dat<-as.data.frame(matrix(NA,n.r*n.c,3))
	cnt<-1
	for(i in 1:n.r)
		for(j in 1:n.c){
			dat[cnt,1]<-x[i,j]
			dat[cnt,2]<-rownames(x)[i]
			dat[cnt,3]<-colnames(x)[j]
			cnt<-cnt+1
		}
	dat<-cbind(dat,0)
	dat<-cbind(dat,0)
	names(dat)<-c("cor","row","col","x.o","y.o")	
	p<-qplot(x.o,y.o,data=dat,facets=row~col,size=abs(cor),colour=cor)+
			scale_size(limits=c(0,1),range=c(0,size))+xlim(c(-1,1))+ylim(c(-1,1))
	p<-p+scale_colour_gradient(limits=c(-1,1),low="#B71B1A",high="#3B4FB8")
	o <- theme(panel.grid.minor = element_blank(), panel.grid.major = element_blank(), 
			axis.ticks = element_blank(), axis.text.y = element_blank(), 
			axis.text.x = element_blank(), axis.title.y = element_blank(), 
			axis.title.x = element_blank())
	p+o
}

\name{cor.matrix}
\alias{cor.matrix}
\title{cor.matrix}
\description{
  Creates a correlation matrix 
}
\usage{
cor.matrix(variables,with.variables,data=NULL,test=cor.test,...)
}
\arguments{
  \item{variables}{variables}
  \item{with.variables}{An optional set of variables to correlate with \code{variables}. If
  nothing is specified, all variables in \code{variables} are correlated with themselves. }
  \item{data}{A data.frame from which the variables and factor will be selected.}
  \item{test}{A function whose first two arguments are the variables upon which the correlation will be calculated,
  and whose result is an object of class \code{htest}.}
  \item{\dots}{further arguments for \code{test}.}  
}
\seealso{
  \code{\link{cor.test}}
  \code{\link{as.matrix.cor.matrix}}
}
\value{
  A \code{multi.test} object, representing a table of the results of \code{func} 
  applied to each of the variables.
}  
\examples{
dat<-data.frame(aa=rnorm(100),bb=rnorm(100),cc=rnorm(100),dd=rnorm(100))
dat$aa<-dat$aa+dat$dd
dat$cc<-dat$cc+dat$aa
cor.matrix(dat,test=cor.test)
cor.matrix(d(aa,cc),data=dat,test=cor.test,method="kendall")
cor.matrix(d(aa,cc),d(dd,bb),data=dat,test=cor.test,method="spearman")
} 

\name{onesample.plot}
\alias{onesample.plot}
\title{onesample.plot}
\description{
  plots for one sample tests
}
\usage{
onesample.plot(variables,data=NULL,test.value,scale=FALSE,type="hist",alpha=.2)
}
\arguments{
  \item{variables}{An expression denoting a set of variable.}
  \item{data}{A data.frame from which the variables will be selected.}
  \item{test.value}{null hypothesis test value}
  \item{scale}{scale variables}
  \item{type}{type of plot. 'hist' or 'box' are allowed}
  \item{alpha}{transparency of points for box plot}
}
\examples{

data(mtcars)
onesample.plot(variables=d(mpg,cyl,disp,hp,drat,wt,qsec,vs,am,
gear,carb),data=mtcars,type='hist')

onesample.plot(variables=d(mpg,cyl,disp,hp,drat,wt,qsec,vs,am,
gear,carb),data=mtcars,type='box',alpha=1)

} 

\name{print.contin.tests}
\alias{print.contin.tests}
\title{Print method }
\description{
  Print object of class \code{"contin.tests"} in nice layout.
}
\usage{
\method{print}{contin.tests}(x,test.digits, \dots)
}
\arguments{
  \item{x}{Object of class \code{"contin.tests"}.}
  \item{test.digits}{Number of digits to be printed} 
  \item{\dots}{further arguments to be passed to or from methods.}  
}

\value{
  none
}

 \name{print.cor.matrix}
\alias{print.cor.matrix}
\title{Print method}
\description{
  Print object of class \code{"cor.matrix"} in nice layout.
}
\usage{
\method{print}{cor.matrix}(x,digits=4,N=TRUE,CI=TRUE,stat=TRUE,p.value=TRUE,...)
}
\arguments{
  \item{x}{Object of class \code{"cor.matrix"}.}
  \item{digits}{Number of digits to round to.}
  \item{N}{Logical. print a row for sample size.}
  \item{CI}{Logical. print a row for confidence intervals if they exist.}
  \item{stat}{Logical. print a row for test statistics.}
  \item{p.value}{Logical. print a row for p-values.}
  \item{\dots}{further arguments}  
}
\value{
  none
} 

\name{add.mantel.haenszel}
\alias{add.mantel.haenszel}
\title{
  Apply the Mantel-Haenszel test to a Contingency Table
}
\description{
  Applies and adds the Cochran-Mantel-Haenzsel test to a \code{contingency.tables} object. The Cochran-Mantel-Haenzsel tests 
  the independence of two nominal variables, stratified by a third nominal variable, assuming no three way interaction.
}
\usage{
add.mantel.haenszel(tables,conservative=FALSE)
}
\arguments{
  \item{tables}{An object of class \code{contingency.tables}}
  \item{conservative}{Should a continuity 'correction' be applied}
}
\details{
This is a convenience function wrapping \code{mantelhaen.test} in a \code{add.cross.strata.test} call.
See \code{\link{mantelhaen.test}} for further details.
}
\value{
  A \code{contingency.tables} object identical to \code{tables}, but with the test applied to each table. 
}
\seealso{
  \code{\link{add.cross.strata.test}}
  \code{\link{add.test}}
  \code{\link{mantelhaen.test}}
}
\examples{
dat<-data.frame(a=rnorm(100)>.5,b=rnorm(100)>0,c=rnorm(100)>(-.5))
tables1<-contingency.tables(
 row.vars=a,
 col.vars=b,
 stratum.var=c,data=dat)
tables1<-add.mantel.haenszel(tables1)
print(tables1,prop.r=TRUE,prop.c=TRUE,prop.t=FALSE)
} 

\name{qscatter_array}
\alias{qscatter_array}
\title{qscatter_array}
\description{
  Creates an array of scatterplots
}
\usage{
qscatter_array(variables,with.variables,data,x.lab="",y.lab="",
				main="Correlation Array",common.scales=TRUE,alpha=.25)
}
\arguments{
  \item{variables}{variables}
  \item{with.variables}{An optional set of variables to correlate with \code{variables}. If
  nothing is specified, all variables in \code{variables} are correlated with themselves. }
  \item{data}{A data.frame from which the variables will be selected.}
  \item{x.lab}{A label for the x axis}
  \item{y.lab}{A label for the y axis}
  \item{main}{A label for the plot}
  \item{common.scales}{should common x and y scales be used.}
  \item{alpha}{alpha transparency}
}

\examples{
data(mtcars)
qscatter_array(d(cyl,disp,hp,drat),
	data=mtcars) + geom_smooth(method="lm")
qscatter_array(d(cyl,disp,hp,drat),d(wt,carb),data=mtcars,common.scales=FALSE)
} 

\name{two.sample.test}
\alias{two.sample.test}
\title{Two Sample Test}
\description{
  Performs a two independent sample test. 
}
\usage{
two.sample.test(formula,data=NULL,test=t.test,...)
}
\arguments{
  \item{formula}{A formula, the left hand side of which indicated the outcomes, and the right hand side of which contains the factor}
  \item{data}{A data.frame}
  \item{test}{A function whose first two arguments are the two-samples to be tested,
  and whose result is an object of class \code{htest}.}
  \item{\dots}{further arguments for test}  
}
\seealso{
  \code{\link{t.test}}
  \code{\link{ks.test}}
  \code{\link{wilcox.test}}
}
\value{
  A \code{multi.test} object, representing a table of the results of \code{test} applied to each of the variables.
}  
\examples{
dat<-data.frame(a=rnorm(100),b=rnorm(100),c=rnorm(100),d=rnorm(100)>(-.5))
two.sample.test(d(a,b) ~ d,dat,ks.test)
two.sample.test(a ~ dich(b,cut=0) ,dat,t.test)
two.sample.test(d(a^2,abs(b),c)~d,dat,wilcox.test)
}

\name{k.sample.test}
\alias{k.sample.test}
\title{K Sample Test}
\description{
  Performs a K independent sample test. 
}
\usage{
k.sample.test(formula,data,test=oneway.test,...)
}
\arguments{
 \item{formula}{A formula, the left hand side of which indicated the outcomes, and the right hand side of which contains the factor}
  \item{data}{A data.frame}
  \item{test}{A function whose first argument is a formula with the outcome on the lhs and the factor on the rhs. 
  The second argument should be the data to be used for the formula. The result of the function should be an object of class \code{htest}.}
  \item{\dots}{further arguments for func}  

}
\seealso{
  \code{\link{oneway.test}}
  \code{\link{kruskal.test}}
  \code{\link{wilcox.test}}
}
\value{
  A \code{multi.test} object, representing a table of the results of \code{func} applied to each of the variables.
}  
\examples{
dat<-data.frame(a=rnorm(100),b=rnorm(100),c=rnorm(100),d=cut(rnorm(100),4))
k.sample.test(d(a,b)~d,dat)
k.sample.test(dat[,-4]~dat$d,var.equal=TRUE)
k.sample.test(d(a,c)~d,dat,kruskal.test)
} 

\name{likelihood.test}
\alias{likelihood.test}
\title{
  Likelihood Ratio (G test) for contingency tables
}
\description{
  Performs a likelihood ratio test of independence 
}
\usage{
likelihood.test(x,y=NULL,conservative=FALSE)
}
\arguments{
  \item{x}{A vector or a matrix}
  \item{y}{A vector that is ignored if x is a matrix and required if x is a vector}
  \item{conservative}{If \code{TRUE}, the Williams' continuity correction is used}
}
\value{
A list with class "htest" containing the following components:
\item{statistic}{the value the chi-squared test statistic. }
\item{parameter}{
the degrees of freedom of the approximate chi-squared distribution of the test statistic.
}
\item{p.value}{the p-value for the test.}
\item{method}{a character string indicating the type of test performed, 
and whether the continuity correction was used.}
\item{data.name}{a character string giving the name(s) of the data.}
}
\author{
Pete Hurd and Ian Fellows
}

\seealso{
  \code{\link{chisq.test}}
}
\examples{
data(InsectSprays)
likelihood.test(InsectSprays$count>7,InsectSprays$spray)
}

\name{one.sample.test}
\alias{one.sample.test}
\title{One Sample Test}
\description{
  Performs a one sample test. 
}
\usage{
one.sample.test(variables,data=NULL,test=t.test,...)
}
\arguments{
  \item{variables}{A variable or dataframe of variables}
  \item{data}{The data frame in which variables is evaluated}
  \item{test}{A function whose first argument is the sample to be tested,
  and whose result is an object of class \code{htest}.}
  \item{\dots}{further arguments for func}  
}
\seealso{
  \code{\link{t.test}}
  \code{\link{shapiro.test}}
}
\value{
  A \code{multi.test} object, representing a table of the results of \code{test} applied to each of the variables.
}  
\examples{
data(anorexia)

#are subjects' weights at baseline and endpoint significantly different from normal
one.sample.test(variables=d(Prewt,Postwt),
	data=anorexia,
	test=shapiro.test)

#does CBT work at increasing mean wt
anorexia.sub<-subset(anorexia,Treat=="CBT")
one.sample.test(variables=Postwt-Prewt,
	data=anorexia.sub,
	test=t.test)

} 

\name{deducer}
\alias{deducer}
\alias{data.viewer}
\title{GUI Access functions}
\description{
  splits a variable into two groups
}
\usage{
deducer(cmd=NULL)

data.viewer()
}
\arguments{
  \item{cmd}{The command to be executed}
}

\name{dich}
\alias{dich}
\title{dich}
\description{
  splits a variable into two groups
}
\usage{
dich(variables,data=NULL,cut=NULL,group1=NULL,group2=NULL)
}
\arguments{
  \item{variables}{variables to be dichotomized}
  \item{data}{A data.frame}
  \item{cut}{An optional cut point dividing \code{factor} into two groups.}
  \item{group1}{An optional vector of levels of \code{factor} defining group 1.}
  \item{group2}{An optional vector of levels of \code{factor} defining group 2.}
}
\value{
  a data.frame containing the variables, recoded into two groups.
} 

 \name{contin.tests.to.table}
\alias{contin.tests.to.table}
\title{
  contin.tests.to.table
}
\description{
  Makes a nice table out of a \code{contin.tests} object
}
\usage{
contin.tests.to.table(tests,test.digits=3,...)
}
\arguments{
  \item{tests}{a \code{contin.tests} object}
  \item{test.digits}{The number of digits to round to}
  \item{\dots}{other paramaters}
}
\value{
  A nice table
}

\name{summarylm}
\alias{summarylm}
\title{
  Summary table for a linear model
}
\description{
  Computes the coefficients, std. errors, t values, and p-values for a linear model in the presence of possible heteroskedasticity.
}
\usage{
summarylm(object,correlation=FALSE,symbolic.cor = FALSE,white.adjust=FALSE,...)
}
\arguments{
  \item{object}{an object of class lm.}
  \item{correlation}{a logical value indicating whether parameter correlations should be printed.}
  \item{symbolic.cor}{logical. If TRUE, print the correlations in a symbolic form (see symnum) rather than as numbers. Effective only
  						if white.adjust is FALSE.}
  \item{white.adjust}{value passed to \code{hccm} indicating the type of robust adjustment to be used. If TRUE, type is assumed to be 'hc3'}
  \item{...}{additional parameters passed to stats::summary.lm}
}
\details{
If white.adjust is false, the function returns a value identical to stats::summary.lm. Otherwise, robust summaries are computed
}
\value{
  A summary table
}
\examples{
ctl <- c(4.17,5.58,5.18,6.11,4.50,4.61,5.17,4.53,5.33,5.14)
trt <- c(4.81,4.17,4.41,3.59,5.87,3.83,6.03,4.89,4.32,4.69)
group <- gl(2,10,20, labels=c("Ctl","Trt"))
weight <- c((ctl-mean(ctl))*10+mean(ctl), trt)
lm.D9 <- lm(weight ~ group)
summarylm(lm.D9,white.adjust=TRUE)
}

\name{chi.noncentral.conf}
\alias{chi.noncentral.conf}
\title{
  Non-central Chi-Squared Confidence Interval
}
\description{
  Confidence interval for the Non-centrality parameter of Non-central chi-squared distribution
}
\usage{
chi.noncentral.conf(chival,df,conf,prec=.00001)
}
\arguments{
  \item{chival}{The observed Chi-Squared value}
  \item{conf}{The confidence level (e.g. .95)}
  \item{df}{Degrees of freedom}
  \item{prec}{Precision of estimate}

}
\value{
  A 2X2 matrix whose rows represent the upper and lower bounds, and whose columns represent the parameter value and upper tail percentiles.
}
\seealso{
  \code{\link{Chisquare}}
}
\references{
  Smithson, M.J. (2003). Confidence Intervals, Quantitative Applications in the Social Sciences Series, No. 140. Thousand Oaks, CA: Sage.
}
\examples{

chi.noncentral.conf(6,1,.95)
#            Result:

#      Non-Central          %
#Lower   0.2089385 0.97500899
#Upper  19.4443359 0.02499302
}  

\name{recode.variables}
\alias{recode.variables}
\title{
  Recode
}
\description{
    Recodes a set of variables according to a set of rules
}
\usage{
recode.variables(data,recodes)
}
\arguments{
  \item{data}{A \code{data.frame} to be recoded}
  \item{recodes}{ Definition of the recoding rules. See details}
}
\details{
\code{recodes} contains a set of recoding rules separated by ";".
There are three different types of recoding rules:

1. The simplest codes one value to another. If we wish to recode 1 into 2, we could use the rule \code{"1->2;"}.

2. A range of values can be coded to a single value using \code{"1:3->4;"}. 
This rule would code all values between 1 and 3 inclusive into 4. For factors, a value is 
between two levels if it is between them in the factor ordering. 
One sided ranges can be specified using the Lo and Hi key words (e.g.\code{"Lo:3->0; 4:Hi->1"})

3. Default conditions can be coded using "else." For example, if we wish to recode all 
values >=0 to 1 and all values <0 to missing, we could use (\code{"0:Hi->1; else->NA"})
}
\value{
  returns a recoded \code{data.frame}
}
\author{
Ian Fellows adapted from code by John Fox
}
\examples{
data<-data.frame(a=rnorm(100),b=rnorm(100),male=rnorm(100)>0)
recode.variables(data[c("a","b")] , "Lo:0 -> 0;0:Hi -> 1;")
data[c("male")] <- recode.variables(data[c("male")] , "1 -> 'Male';0 -> 'Female';else -> NA;")
}

\name{devel}
\alias{addComponent}
\alias{getSize}
\alias{setSize}
\alias{execute}
\alias{ButtonGroupWidget}
\alias{CheckBoxesWidget}
\alias{DeducerMain}
\alias{JLabel}
\alias{RDialogMonitor}
\alias{RDialog}
\alias{SimpleRDialog}
\alias{SimpleRSubDialog}
\alias{SingleVariableWidget}
\alias{SliderWidget}
\alias{TextAreaWidget}
\alias{VariableListWidget}
\alias{VariableSelectorWidget}
\alias{AddRemoveButtons}
\alias{ListWidget}
\alias{ComboBoxWidget}
\alias{TextFieldWidget}
\alias{ObjectChooserWidget}
\title{
  Deducer's plug-in development tools
}
\description{
  functions pertaining to GUI development
}
\usage{
addComponent(container, component, top, right, bottom, 
	left, topType = "REL", rightType = "REL", bottomType = "REL", 
	leftType = "REL")
getSize(component)
setSize(component,width,height)
execute(cmd)

ButtonGroupWidget 
CheckBoxesWidget 
DeducerMain 
JLabel 
RDialog
SimpleRDialog
SimpleRSubDialog 
SingleVariableWidget 
SliderWidget 
TextAreaWidget
VariableListWidget 
VariableSelectorWidget
ComboBoxWidget
RDialogMonitor
ListWidget
AddRemoveButtons
TextFieldWidget
ObjectChooserWidget
}
\arguments{
  \item{container}{A Java Swing container with Anchor layout}
  \item{component}{a Java Swing component }
  \item{top}{location of top of component 0 - 1000}
  \item{right}{location of right of component 0 - 1000}
  \item{bottom}{location of bottom of component 0 - 1000}
  \item{left}{location of left of component 0 - 1000}
  \item{topType}{Type of constraint on top of component. Can be "REL", "ABS", or "NONE"}
  \item{rightType}{Type of constraint on right of component. Can be "REL", "ABS", or "NONE"}
  \item{bottomType}{Type of constraint on bottom of component. Can be "REL", "ABS", or "NONE"}
  \item{leftType}{Type of constraint on left of component. Can be "REL", "ABS", or "NONE"}
  \item{height}{new height of component or window in pixels }
  \item{width}{new width of component or window in pixels }
  \item{cmd}{the command to be executed}
}
\details{
addComponent adds a Java object of class Component to a container 
(usually an RDialog or SimpleRDialog). the location of the component is
determined by the top, right, bottom, and left arguments, which are numbers
between 1 and 1000 indicating the distance from either the top (or left) of the
container, with 1000 indicating the opposite side of the container. Each side
can be constrained in three different ways. If the Type is "REL", the side will
scale proportional to the container when the container is resized. If it is
"ABS", it is not rescaled. If it is "NONE", the location of that side is determined
by the componet's preferred size, which can be set with the "setPreferedSize" method.

getSize gets the height and width

setSize sets the height and width

execute executes a character representing a command, as if it were entered into the console

The rest of the items are references to the Java classes of commonly used GUI components.
see www.deducer.org for more details and usage.

}

\name{add.cross.strata.test}
\alias{add.cross.strata.test}
\title{
  Apply a Stratified test to a Contingency Table
}
\description{
  Applies and adds a hypothesis test to a \code{contingency.tables} object.
}
\usage{
add.cross.strata.test(tables,name,htests,types=c("asymptotic","monte.carlo","exact"))
}
\arguments{
  \item{tables}{An object of class \code{contingency.tables}}
  \item{name}{The name of the hypothesis test}
  \item{htests}{A function or list of functions which take a three dimensional array as it's argument
  				and returns an object of class \code{htest} }
  \item{types}{A character vector with the same number of items as htests, indicating what type of test
  				was done}
}
\value{
  A \code{contingency.tables} object identical to \code{tables}, but with the test applied to each table. 
}
\seealso{
  \code{\link{add.mantel.haenszel}}
  \code{\link{add.test}}
}
\examples{
dat<-data.frame(a=rnorm(100)>.5,b=rnorm(100)>0,c=rnorm(100)>(-.5))
tables<-contingency.tables(
 row.vars=a,
 col.vars=b,
 stratum.var=c,data=dat)
add.cross.strata.test(tables,"Mantel-Haenszel",list(function(x) mantelhaen.test(x,correct=FALSE)),
 "asymptotic")
tables
}

\name{ggcorplot}
\alias{ggcorplot}
\title{
  Correlation matrix
}
\author{
Mike Lawrence and Ian Fellows
}
\description{
  Plots a correlation matrix
}
\usage{
ggcorplot(cor.mat,data=NULL,lines=TRUE,line.method=c("lm","loess"),type="points",
		alpha=.25,main="auto",var_text_size=5,
		cor_text_limits=c(5,25),level=.05)
}
\arguments{
  \item{cor.mat}{a \code{cor.matrix} object to plot}
  \item{data}{the data.frame used to compute the correlation matrix}
  \item{lines}{Logical. Should regression lines be drawn.}
  \item{type}{type of plot. "points" or "bins"}
  \item{line.method}{Character. Type of regression line.}
  \item{alpha}{numeric. level of alpha transparency for the points.}
  \item{main}{Title of the plot. defaults to the method of cor.mat.}
  \item{var_text_size}{size of the diagonal variable names.}
  \item{cor_text_limits}{lower and upper bounds for the size of the correlation text.}
  \item{level}{the size of the test differentiated by text color.}

}
\seealso{
  \code{\link{cor.matrix}}
  \code{\link{qscatter_array}}
}
\examples{
data(mtcars)
corr.mat1<-cor.matrix(variables=d(mpg,carb,carb+rnorm(length(carb))),,
	 data=mtcars,
	 test=cor.test,
	 method='spearman',
	alternative="two.sided",exact=FALSE)
	
p<-ggcorplot(corr.mat1,data = mtcars)
print(p)
\dontrun{

has.hex<-require("hexbin")
if(has.hex){
	data(diamonds)
	corr.mat<-cor.matrix(variables=d(price,carat,color),,
		 data=diamonds,
		 test=cor.test,
		 method='spearman',
		alternative="two.sided")

	p1 <- ggcorplot(cor.mat=corr.mat,data=diamonds,type="bins",
		cor_text_limits=c(5,15),
		lines=FALSE)
	print(p1)
	rm('corr.mat')

}
}

}

\name{plot.cor.matrix}
\alias{plot.cor.matrix}
\title{Plot method}
\description{
  Produces a circle plot for an object of class \code{"plot.cor.matrix"}
}
\usage{
\method{plot}{cor.matrix}(x,y=NULL,size=10,...)
}
\arguments{
  \item{x}{Object of class \code{"cor.matrix"}.}
  \item{y}{unused}
  \item{size}{maximum radius size}
  \item{\dots}{further arguments. unsued}  
}
\value{
  a ggplot object
} 

\name{d}
\alias{d}
\title{
  wrapper for data.frame
}
\description{
  This function creates data frames, tightly coupled collections of
     variables which share many of the properties of matrices and of
     lists, used as the fundamental data structure by most of R's
     modeling software. It is a keystroke saving wrapper for the data.frame function.
     The only difference is that check.names and stringsAsFactors are FALSE by default.
}
\usage{
d(..., row.names = NULL, check.rows = FALSE,
                check.names = FALSE,
                stringsAsFactors = FALSE)
}
\arguments{
     \item{...}{ items}

\item{row.names}{NULL or a single integer or character string
          specifying a column to be used as row names, or a character
          or integer vector giving the row names for the data frame.}

\item{check.rows}{ if TRUE then the rows are checked for consistency of
          length and names.}

\item{check.names}{ logical.  If TRUE then the names of the variables in
          the data frame are checked to ensure that they are
          syntactically valid variable names and are not duplicated.
          If necessary they are adjusted (by make.names) so that
          they are.}

\item{stringsAsFactors}{ logical: should character vectors be converted to
          factors? }
}
\seealso{
  \code{\link{data.frame}}
}
\examples{
x <- d(rnorm(10),1:10)
} 

\name{deducer.addMenu}
\alias{deducer.addMenu}
\alias{deducer.addMenuItem}
\alias{deducer.getMenus}
\alias{deducer.setMenus}
\alias{menuFunctions}
\title{
  Controls Deducer's command line menus
}
\description{
Controls Deducer's command line menus
}
\usage{
deducer.addMenu(name, pos=length(menus)+1)
deducer.setMenus(newMenus)
deducer.getMenus()
deducer.addMenuItem(name, pos=NULL, command, menuName, silent=TRUE)
menuFunctions()
}
\arguments{
  \item{name}{name of item or menu to add}
  \item{pos}{position at which to add the item or menu}
  \item{menuName}{the name of the menu to add the item to}
  \item{command}{A character vector representing the R command to be run}
  \item{silent}{Should the command be executed silently}
  \item{newMenus}{new menus}

  
}
\examples{

#add a menu with two items
deducer.addMenu("TestMenu")
deducer.addMenuItem("test1",,"cat('test1 selected')","TestMenu")
deducer.addMenuItem("test2",,"print(summary(lm(rnorm(100)~rnorm(100))))","TestMenu")

#Add menu to gui if applicable
if(.windowsGUI){
	#winMenuAdd("TestMenu")
	#winMenuAddItem("TestMenu", "test1", "cat('test1 selected')")
	#winMenuAddItem("TestMenu", "test2", "print(summary(lm(rnorm(100)~rnorm(100))))")
}else if(.jgr){
	jgr.addMenu("TestMenu")
	jgr.addMenuItem("TestMenu", "test1", "cat('test1 selected')")
	jgr.addMenuItem("TestMenu", "test2", "print(summary(lm(rnorm(100)~rnorm(100))))")	
}


}

\name{Helpers}
\alias{.assign.classnames}
\alias{.deducer}
\alias{.deducer.loaded}
\alias{.deducerExecute}
\alias{.ensureJRI}
\alias{.jri.initialized}
\alias{.runCmd}
\alias{.dialogGenerators}
\alias{.dialogs}
\alias{.getDialog}
\alias{.jgr}
\alias{.makeIbarDialog}
\alias{.makeIboxLongDialog}
\alias{.makeIboxWideDialog}
\alias{.makeIhistDialog}
\alias{.makeImosaicDialog}
\alias{.makeIpcpDialog}
\alias{.makeIplotDialog}
\alias{.makePairedTestDialog}
\alias{.onUnload}
\alias{.registerDialog}
\alias{.vol}
\alias{.windowsGUI}
\title{
  Helpers
}
\description{
  GUI helpers
}
\usage{
.assign.classnames()
}

\name{extract.counts}
\alias{extract.counts}
\title{
  Extract Contingency Table Arrays
}
\description{
  Extracts the counts of a contingency.tables object
}
\usage{
extract.counts(tables)
}
\arguments{
  \item{tables}{A \code{contingency.table} object}
}
\value{
 A named list of three dimensional arrays. One for each \code{contin.table} in \code{tables}
 }
\seealso{
  \code{\link{contingency.tables}}
}
\examples{
temp.data<-data.frame(a=rnorm(100)>0,b=rnorm(100)>0,gender=rep(c("male","female"),50))
#a vs. b stratified by gender
tab<-contingency.tables(a,b,gender,data=temp.data)
tab

##extract counts
extract.counts(tab)

##Yields something like the following:
#$`a by b`
#, , female
#
#      FALSE TRUE
#FALSE    11    9
#TRUE     15   15
#
#, , male
#
#      FALSE TRUE
#FALSE    10   10
#TRUE     22    8

} 

\name{print.freq.table}
\alias{print.freq.table}
\title{Print method}
\description{
  Print object of class \code{"freq.table"} in nice layout.
}
\usage{
\method{print}{freq.table}(x,\dots)
}
\arguments{
  \item{x}{Object of class \code{"freq.table"}.}
  \item{\dots}{further arguments}  
}

\value{
  none
}
 

\name{print.multi.test}
\alias{print.multi.test}
\title{Print method}
\description{
  Print object of class \code{"multi.test"} in nice layout.
}
\usage{
\method{print}{multi.test}(x,...)
}
\arguments{
  \item{x}{Object of class \code{"multi.test"}.}
  \item{\dots}{further arguments}  
}
\value{
  none
}   

\name{contingency.tables}
\alias{contingency.tables}
\title{
  Contingency Tables
}
\description{
  Creates a contingency.tables object
}
\usage{
contingency.tables(row.vars, col.vars, stratum.var, data=NULL, missing.include=FALSE )
}
\arguments{
  \item{row.vars}{A variable or data frame evaluated in data}
  \item{col.vars}{A variable or data frame evaluated in data}
  \item{stratum.var}{A variable evaluated in data}
  \item{data}{A \code{data.frame}}
  \item{missing.include}{A logical indicating whether a missing category should be included in the table}
}
\value{
 A list with class "contingency.tables." Each element of the list is a single contingency table of 
 class "contin.table" corresponding to each combination of elements of \code{row.vars} and \code{col.vars} 
 stratified by \code{stratum.var}
 }
\seealso{
  \code{\link{extract.counts}}
}
\examples{
temp.data<-data.frame(a=rnorm(100)>0,b=rnorm(100)>0,gender=rep(c("male","female"),50))
#a vs. b stratified by gender
tab<-contingency.tables(a,b,gender,data=temp.data)
tab

##add in chi-squared tests
tab<-add.chi.squared(tab)
tab
} 

\name{as.matrix.cor.matrix}
\alias{as.matrix.cor.matrix}
\title{as.matrix method}
\description{
  as matrix
}
\usage{
\method{as.matrix}{cor.matrix}(x,...)
}
\arguments{
  \item{x}{Object of class \code{"cor.matrix"}.}
  \item{\dots}{further arguments. unsued}  
}
\value{
  a matrix
} 

\name{get.objects}
\alias{get.objects}
\title{
  get objects
}
\description{
  Enumerates all objects of a certain class
}
\usage{
get.objects(cn,env = globalenv(),includeInherited=TRUE)
}
\arguments{
  \item{cn}{The name of the class}
  \item{env}{environment to look in}
  \item{includeInherited}{Should objects inheriting cn be included}
}
\value{
a character vector
}

 \name{perm.t.test}
\alias{perm.t.test}
\title{
  Permutation t-test
}
\description{
  Two Sample t-test via monte-carlo permutation
}
\usage{
perm.t.test(x,y,statistic=c("t","mean"),
			alternative=c("two.sided", "less", "greater"), midp=TRUE, B=10000)
}
\arguments{
  \item{x}{a numeric vector containing the first sample}
  \item{y}{a numeric vector containing the second sample}
  \item{statistic}{The statistic to be permuted. See details}
  \item{alternative}{The alternative hypothesis}
  \item{midp}{should the mid p-value be used}
  \item{B}{The number of monte-carlo samples to be generated}
}
\details{
This function performs a two sample permutation test. If the mean is permuted, then the test assumes exchangability
between the two samples. if the t-statistic is used, the test assumes either exchangability or a sufficiently large
sample size. Because there is little lost in the way of power, and the assumptions are weaker, the t-statistic is
used by default.
}
\value{
A list with class "htest" containing the following components:
\item{statistic}{The observed value of the statistic. }
\item{p.value}{the p-value for the test.}
\item{method}{a character string indicating the type of test performed.}
\item{data.name}{a character string giving the name(s) of the data.}
\item{B}{The number of samples generated}
\item{alternative}{the direction of the test}
}
\seealso{
  \code{\link{t.test}}
}
\examples{
perm.t.test(rnorm(100),runif(100,-.5,.5))
}

\name{print.contin.table}
\alias{print.contin.table}
\title{Print method}
\description{
  Print object of class \code{"contin.table"} in nice layout.
}
\usage{
\method{print}{contin.table}(
	x,digits=3,prop.r=TRUE,prop.c=TRUE,prop.t=TRUE,
	expected.n=FALSE,residuals=FALSE,std.residuals=FALSE,
	adj.residuals=FALSE,no.tables=FALSE,...)
}
\arguments{
  \item{x}{Object of class \code{"contin.table"}.}
  \item{digits}{Number of digits to round to.}
  \item{prop.r}{Logical. print row proportions.}
  \item{prop.c}{Logical. print column proportions.}
  \item{prop.t}{Logical. print proportions.}
  \item{expected.n}{Logical print expected cell counts.}
  \item{residuals}{Logical. print residuals.}
  \item{std.residuals}{Logical. print standardized residuals.}
  \item{adj.residuals}{Logical. Print Adjusted residuals}
  \item{no.tables}{Logical. Suppress tables}
  \item{\dots}{further arguments}  
}
\author{
Ian Fellows based on the CrossTable function from the gmodels package maintained by Gregory R. Warnes
}
\value{
  none
} 

\name{table.to.data}
\alias{table.to.data}
\title{
  Table --> data.frame
}
\description{
  Creates a data.frame from a table
}
\usage{
table.to.data(x)
}
\arguments{
  \item{x}{A matrix or table representing the cross tabulation of two variables}

}
\value{
  A two column data.frame where each row is an observation and each column is a variable.
}
\seealso{
  \code{\link{xtabs}}
}
\examples{
tab<-matrix(c(4,5,6,9,7,3),ncol=3)
tab
table.to.data(tab)

} 

\name{multi.test}
\alias{multi.test}
\title{multi.test}
\description{
  Creates a table from a list of htests
}
\usage{
multi.test(tests)
}
\arguments{
  \item{tests}{A named list of htest objects representing the same test applied to a number of different conditions or variables.}
}
\value{
  A \code{multi.test} object, representing a table of the \code{htest} objects.
}  

\name{sort.data.frame}
\alias{sort.data.frame}
\title{
  Sort Data
}
\description{
    Sorts a data frame
}
\usage{
\method{sort}{data.frame}(x, decreasing, by, ...)
}
\arguments{
  \item{x}{A \code{data.frame} to be sorted}
  \item{decreasing}{unused}
  \item{by}{A character, a one sided formula, or an expression indicating the sorting order}
  \item{\dots}{further arguments}  
}
\details{
  If \code{by} is a formula, or a character vector coerce-able into a formula, 
  \code{x} is sorted by each element of the formula, with ties broken by subsequent elements. 
  Elements preceded by a '-' indicate descending order, otherwise ascending order is used. Parentheses or any formula
  operator other than + and - are ignored, so sorting by \code{a*b} will sort based on the product of a and b.
  
  If \code{by} is not a formula, a \code{~} is appended to the left hand side of the call, and coerced into
  a formula.
  
  The decreasing argument is included for generic method consistency, and is not used.
}
\author{
Ian Fellows adapted from code by Ari Friedman and Kevin Wright
}
\value{
  returns \code{x}, sorted.
}
\seealso{
  \code{\link{sort}}
  \code{\link{order}}
}
\examples{
data(mtcars)

#sort by the number of cylenders
sort(mtcars, by= ~cyl)
sort(mtcars, by= cyl) #identical: no need for ~

#sort in descending order
sort(mtcars, by= -cyl)

#break ties with horse power
sort(mtcars,by= cyl +hp )
sort(mtcars,by= cyl -hp )

#randomly permute the data
sort(mtcars,by= rnorm(nrow(mtcars)) )

#reverse order
sort(mtcars,by= nrow(mtcars):1 )

#sort by squared deviation from mean hp
sort(mtcars,by= -(hp-mean(hp))^2 )
sort(mtcars,by= "-(hp-mean(hp))^2" ) #identical
}

\name{descriptive.table}
\alias{descriptive.table}
\title{
  Table of Descriptives
}
\description{
    Table of descriptive statistics, possibly stratified
}
\usage{
descriptive.table(vars,
	strata,
	data,
	func.names = c("Mean","St. Deviation","Median",
		"25th Percentile","75th Percentile",
		"Minimum","Maximum","Skew","Kurtosis","Valid N"),
	func.additional)
}
\arguments{
  \item{vars}{A variable or data.frame containing variables on which to run descriptive statistics.}
  \item{data}{The data frame in which vars is evaluated}
  \item{strata}{A variable or data.frame containing variables on which to stratify}
  \item{func.names}{A character vector of built-in statistics}
  \item{func.additional}{A named list of functions. Each function should take a numeric vector as its argument, and return a single value}
}
\value{
  Returns a list of \code{matrix} objects containing descriptive information on all variables in \code{dat}. 
  One for each level or combination of levels in \code{strata}.
}
\seealso{
  \code{\link{frequencies}}
  \code{\link{mean}}
  \code{\link{by}}
}
\examples{
data(mtcars)
##means and standard deviations
descriptive.table(vars = d(mpg,hp),data= mtcars,
	func.names =c("Mean","St. Deviation","Valid N"))
##stratifying by cyl
descriptive.table(vars = d(mpg,hp) ,
	strata = d(cyl),data= mtcars,
	func.names =c("Mean","St. Deviation","Valid N"))
	
	
func.list=list(mean.deviance=function(x) mean(abs(x-mean(x))))

##Adding deviance as a statistic
descriptive.table(vars = d(mpg,hp) ,
	strata = d(cyl),data= mtcars,
	func.names =c("Mean","St. Deviation","Valid N"),func.additional=func.list)
}

\name{perm}
\alias{perm}
\title{
  Vector Permutations
}
\description{
  Enumerates all permutations of a vector
}
\usage{
perm(vec,duplicates=FALSE)
}
\arguments{
  \item{vec}{The vector to permute}
  \item{duplicates}{Should duplicate permutations be listed}
}
\value{
  Returns a matrix where each row is a permutation of vec. All possible permutations are listed, and if \code{duplicates=TRUE} non-unique permutations are also listed.
}
\seealso{
  \code{\link{sample}}
}
\examples{
perm(1:4)
perm(LETTERS[4:8])

}

\name{add.test}
\alias{add.test}
\alias{add.chi.squared}
\alias{add.likelihood.ratio}
\alias{add.fishers.exact}
\alias{add.correlation}
\alias{add.kruskal}
\title{
  Apply a test to a Contingency Tables object
}
\description{
  Applies and adds a test to a \code{contingency.tables} object. 
}
\usage{
add.test(tables,name,htests,types=c("asymptotic","monte.carlo","exact"))

add.chi.squared(tables, simulate.p.value = FALSE, B = 10000)

add.likelihood.ratio(tables, conservative = FALSE, simulate.p.value = FALSE, B = 10000)

add.fishers.exact(tables, simulate.p.value = FALSE, B = 10000)

add.correlation(tables,method=c("spearman","kendall"))

add.kruskal(tables,nominal=c("both","rows","cols"))
}
\arguments{
  \item{tables}{An object of class \code{contingency.tables}}
  \item{name}{Name of the test}
  \item{htests}{A function or list of functions which take a matrix as it's argument
  				and returns an object of class \code{htest} }
  \item{types}{A character vector with the same number of items as \code{htests}, indicating what type of test
  				was done}
  \item{conservative}{Should a conservative p-value be computed. i.e. One with a continuity correction for
  				asymptotic tests and not using the mid p-value for exact and approximate tests }
  \item{simulate.p.value}{If \code{TRUE} p-values will be computed via monte carlo simulation}
  \item{B}{the number of samples for the monte carlo simulation}
  \item{method}{the type of correlation}
  \item{nominal}{Should the rows or columns be considered nominal.}
  
}
\details{
add.test applies a supplied list of tests to all of the tables in \code{tables}. 

add.chi.squared is a wrapper function applying the \code{\link{chisq.test}} function to each table.
add.likelihood.ratio is a wrapper function applying the \code{\link{likelihood.test}} function to each table.
add.fishers.exact is a wrapper function applying the \code{\link{fisher.test}} function to each table.
add.correlation is a wrapper function applying the \code{\link{cor.test}} function to each table.
add.kruskal is a wrapper function applying the \code{\link{kruskal.test}} function to each table.

}
\value{
  A \code{contingency.tables} object identical to \code{tables}, but with the test applied to each table. 
}
\seealso{
  \code{\link{add.cross.strata.test}}
  \code{\link{likelihood.test}}
  \code{\link{cor.test}}
  \code{\link{kruskal.test}} 
}
\examples{
dat<-data.frame(a=rnorm(100)>.5,b=rnorm(100)>0,c=rnorm(100)>(-.5))
tables<-contingency.tables(
	row.vars=a,
	col.vars=b,
	stratum.var=c,data=dat)
tables<-add.chi.squared(tables,simulate.p.value=TRUE,B=10000)
tables<-add.likelihood.ratio(tables)
tables<-add.fishers.exact(tables)
tables<-add.correlation(tables,method='kendall')
tables<-add.kruskal(tables)
tables<-add.mantel.haenszel(tables)
print(tables)
remove(tables)
}  

\name{frequencies}
\alias{frequencies}
\title{
  Frequency Tables
}
\description{
  Creates a set of frequency tables.
}
\usage{
frequencies(data,r.digits=1)
}
\arguments{
  \item{data}{A data.frame containing the variables on which to run frequencies}
  \item{r.digits}{how many digits should the percentages be rounded to}
}
\value{
  Returns a list of \code{freq.table} objects. One for each variable in \code{data}.
}
\seealso{
  \code{\link{table}}
  \code{\link{xtabs}}
  \code{\link{descriptive.table}}
  \code{\link{prop.table}}
}
\examples{
dat<-data.frame(rnorm(100)>0,trunc(runif(100,0,5)))
##rounding to 1
frequencies(dat)
##rounding to 4
frequencies(dat,4)
}

\name{oneway.plot}
\alias{oneway.plot}
\title{One Way PLot}
\description{
  plots a categorical variable against a series of continuous variables
}
\usage{
oneway.plot(formula,data=NULL,alpha=.2,
		box=TRUE,points=TRUE,scale=FALSE)
}
\arguments{
 \item{formula}{A formula, the left hand side of which indicated the outcomes, and the right hand side of which contains the factor}
  \item{data}{A data.frame}
  \item{alpha}{alpha transparency level for the points.}
  \item{box}{prints boxplot}
  \item{points}{prints jitter plot}
  \item{scale}{standardize the variables prior to plotting}
}
\value{
  a ggplot object
} 
\examples{

oneway.plot(d(DriversKilled, drivers, front, rear,   kms, PetrolPrice)~law,as.data.frame(Seatbelts))

} 

\name{rocplot}
\alias{rocplot}
\title{
 ROC Plot for a logistic regression model
}
\description{
  Plots the ROC Curve
}
\usage{
rocplot(logistic.model,diag=TRUE,pred.prob.labels=FALSE,prob.label.digits=3,AUC=TRUE)
}
\arguments{
  \item{logistic.model}{a glm object with binomial link function.}
  \item{diag}{a logical value indicating whether a diagonal reference line should be displayed.}
  \item{pred.prob.labels}{a logical value indicating whether the 
  predictive probabilities should be displayed}
  \item{prob.label.digits}{The number of digits of the predictive probabilities to be displayed.}
  \item{AUC}{a logical value indicating whether the estimated area under the curve should be displayed}
}
\author{
Ian Fellows adapted from the lroc function by Virasakdi Chongsuvivatwong
}
\value{
  a ggplot object
}
\examples{
model.glm <- glm(formula=income>5930.5 ~ education + women + type,
	family=binomial(),data=Prestige,na.action=na.omit)
rocplot(model.glm)
}
